##############################
####### 17/9/07 ##############
##############################

import Bladex
import Reference
import PA4AllyCombat
import AniSound
import BCopy
import math
import whrandom
import Actions
import CharStats
import AuxFuncs
import B3DLib
import Damage
import PA4Ally_Def
import Basic_Funcs
import GameStateAux
import GenFX
import ScorerActions
import InitDataField
import pocimac
import ItemTypes
import QuiverTypes


TRUE = 1==1
FALSE = not TRUE


W_FLAG_1H=0     #One handed _whatever_ weapon
W_FLAG_2W=1	#Two handed sword
W_FLAG_AXE=2	#Two handed axe
W_FLAG_SP=3     #Two handed spear


PI = math.pi
TWOPI = PI*2

CHOOSE_FIRST  = -1
CHOOSE_SECOND =  1
CHOOSE_EITHER =  0

ROUTE_WATCH=0  #Watch mode
ROUTE_BAY=1    #Performing a bay route
ROUTE_CHASE=2  #Chase a character
ROUTE_SINGLE=3 #Following a single route (going to just a point)
ROUTE_BOWING=4 #Bowing (OR trying to bow) an enemy


def AmIRelaxing(entity):
	per=Bladex.GetEntity(entity)
	if per.AnimName[:3] == "rlx" or per.AnimName[:3] == "Rlx":
		return 1
	return 0
	
	
def CheckIfAlly (EntityName):
	me=Bladex.GetEntity(EntityName)
	if me:	
		try:			
			en=me.Data.EnemyName
		except AttributeError:
			return TRUE
	return FALSE # returns TRUE for enemies of Player
	        
	 	   

def HasABow(entity):
	inv=entity.GetInventory()
	if inv.HoldingBow:
		return TRUE
	return FALSE	   
	 	   
	 	   
UnarmedDamage=[1,3,6,10,16,22,30,40,50,60,75,95,120,150,180,240,300,360,450,600]   
	 	   
	 	      
def GetUnarmedDamage(EntityName):
	me=Bladex.GetEntity(EntityName)
	global UnarmedDamage
	lvl=me.Level
	if lvl>=19:
		return UnarmedDamage[19]
	else:
		return UnarmedDamage[lvl]

	 	   
	 	   
	 	   
def ChuckIt(EntityName, ObjectName):
	me=Bladex.GetEntity(EntityName)
	inv=me.GetInventory()
	if me and me.Life>0:
		me.Data.ChuckPotato(EntityName)
		
	 	   
	 	   
	 	   
def UsePotion (EntityName):
	import pocimac
	me=Bladex.GetEntity(EntityName)	
	if me and me.Life >0:
		inv = me.GetInventory()
		for x in range (inv.nObjects):
			item_name = inv.GetObject(x)
			item = Bladex.GetEntity(item_name)
			if item.Data and item.Data.__class__==pocimac.Pocima:
				max_life= CharStats.GetCharMaxLife(me.Kind, me.Level)
				if (me.Life <= max_life/4.0) or (item.Data.Increment and me.Life+item.Data.Increment<=max_life or me.Data.Poisoned):
					# we have found a potion, I hope its the life giving one...
					me.Data.obj_used=item
					item.Data.UsedBy = EntityName
					item.UseFunc(item_name, Actions.USE_FROM_INV)
					return 1
	return 0
	
	
	
def GiveWeaponType(entity):
	per=Bladex.GetEntity(entity)
	inv = per.GetInventory()
	rwp=per.InvRight
	if rwp:
		wpflag=Reference.GiveObjectFlag(rwp)
		if wpflag==Reference.OBJ_STANDARD:
			return W_FLAG_1H
	for x in range(inv.nWeapons):
		weapon_name = inv.GetWeapon(x)
		wp = Bladex.GetEntity(weapon_name)
		if wp:
			if Reference.EntitiesObjectData.has_key(weapon_name):
				object_data = Reference.EntitiesObjectData[weapon_name]
			else:
				object_data = Reference.DefaultObjectData[wp.Kind]
			
			if not object_data[0]==Reference.OBJ_BOW:
				return object_data[5][0]
				break
		else:
			return None
			
			

def DumpMe(entity):
	per=Bladex.GetEntity(entity)		
	per.Position=0,30000,0
		
def RemoveMyCorpse(PersonName, dx, dz):
	me = Bladex.GetEntity(PersonName)
	me.Alpha=1.00
	me.RasterMode="Read"
	me.CastShadows=0
	AuxFuncs.FadeObject(PersonName, 1.00, 0.0, 4.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, DumpMe,(me.Name,))
	
	
def RemoveMyWeapon(WeaponName):
	try:
		wp = Bladex.GetEntity(WeaponName)
		wp.Alpha=1.00
		wp.RasterMode="Read"
		wp.CastShadows=0
		AuxFuncs.FadeObject(WeaponName, 1.00, 0.0, 4.0)
	
		Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, DumpMe,(wp.Name,))
	except:
		print "exception in remove weapon"
		print WeaponName
	
def AllyNPCLevelUpFX(EntityName, ColourGradation, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, LightIntensity, timer="Timer15", timespersec=15, sound=""):


	# ColourGradation=0/1
	# AuraParams=(Size, Alpha, ColourIntensity, HideFrontFaces, HideBackFaces, AlphaMode)
	# AuraGradient=(Gap, r1, g1, b1, alpha1, StartingPoint, r2, g2, b2, alpha2, EndingPoint)
	# AuraVarArgs=(init_size, end_size, init_alpha, end_alpha, time)
	# PSParams=(LevelUpParticleData, ParticleType, ParticleLife, r, g, b, PPS, YGravity, Friction, RandomVelocity, NormalVelocity, FollowFactor, Time2Live, DeathTime)

	ent=Bladex.GetEntity(EntityName)
	if ColourGradation:
		maxlevel=CharStats.GetMaxLevel()
		frlevel=maxlevel/4.0
		fr1level=round(frlevel)
		fr2level=round(2.0*frlevel)
		fr3level=round(3.0*frlevel)
		clevel=ent.Level
		if clevel>fr3level:
			r=255
			g=255*(min(max(0, (maxlevel-clevel)/(maxlevel-fr3level)), 1)) # 255->0
			b=0
		elif clevel>fr2level:
			r=255*(min(max(0, (clevel-fr2level)/(fr3level-fr2level)), 1)) # 0->255
			g=255
			b=0
		elif clevel>fr1level:
			r=0
			g=255
			b=255*(min(max(0, (fr2level-clevel)/(fr2level-fr1level)), 1)) # 255->0
		else:
			r=0
			g=255*(min(max(0, (clevel/fr1level)), 1)) # 0->255
			b=255
		AuraGradient=(AuraGradient[0], r/255.0, g/255.0, b/255.0, AuraGradient[4], AuraGradient[5], r/255.0, g/255.0, b/255.0, AuraGradient[9], AuraGradient[10])
	else:
		r=PSParams[3]
		g=PSParams[4]
		b=PSParams[5]
	LevelUpParticleData=PSParams[0]
	for i in range(PSParams[2]):
		Bladex.SetParticleGVal(PSParams[1], i, r, g, b, LevelUpParticleData[2*i], LevelUpParticleData[2*i+1])
	AuraName=EntityName+"AuraLevelUp"
	a2, b2, c2, d2, e2, f2, g2, h2, i2, j2, k2=AuraName, AuraVar2Args[0], AuraVar2Args[1], AuraVar2Args[2], AuraVar2Args[3], AuraVar2Args[4], 1, "", (), timer, timespersec
	a1, b1, c1, d1, e1, f1, g1, h1, i1, j1, k1=AuraName, AuraVar1Args[0], AuraVar1Args[1], AuraVar1Args[2], AuraVar1Args[3], AuraVar1Args[4], 0, AuxFuncs.FadeAndScaleAura, (a2, b2, c2, d2, e2, f2, g2, h2, i2, j2, k2), timer, timespersec
	alup=Bladex.CreateEntity(AuraName, "Entity Aura", 0, 0, 0)
	alup.SetAuraParams(AuraParams[0], AuraParams[1], AuraParams[2], AuraParams[3], AuraParams[4], AuraParams[5])
	alup.SetAuraGradient(AuraGradient[0], AuraGradient[1], AuraGradient[2], AuraGradient[3], AuraGradient[4], AuraGradient[5], AuraGradient[6], AuraGradient[7], AuraGradient[8], AuraGradient[9], AuraGradient[10])
	ent.Link(alup)
	alup.SetAuraActive(1)
	AuxFuncs.FadeAndScaleAura(a1, b1, c1, d1, e1, f1, g1, h1, i1, j1, k1)
	PSName=EntityName+"PSLevelUp"
	pslup=Bladex.CreateEntity(PSName, "Entity Particle System Dperson", 0, 0, 0)
	pslup.PersonName=EntityName
	pslup.ParticleType=PSParams[1]
	pslup.PPS=PSParams[6]
	pslup.YGravity=PSParams[7]
	pslup.Friction=PSParams[8]
	pslup.RandomVelocity=PSParams[9]
	pslup.NormalVelocity=PSParams[10]
	pslup.FollowFactor=PSParams[11]
	pslup.Time2Live=PSParams[12]
	pslup.Velocity=0.0, 0.0, 0.0
	pslup.DeathTime=Bladex.GetTime()+PSParams[13]
	
	


###########################################################################################################################################################

def AllyDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded):
	vict=Bladex.GetEntity(VictimName)
	if AttackerName:
		attacker=Bladex.GetEntity(AttackerName)
		if attacker and attacker.Person: 
			if not CheckIfAlly(AttackerName):
				return
			if AttackerName=="Player1":
				if  AmIRelaxing(VictimName):
					vict.Wuea=Reference.WUEA_ENDED
					#vict.LaunchAnmType("hurt_f_big")
					Actions.QuickTurnToFaceEntity (vict.Name, "Player1")
					Bladex.AddScheduledFunc(Bladex.GetTime()+0.5,vict.LaunchAnmType,("Wbk_1h",))
				
				
				if WeaponName :
					if WeaponName[:6]=="Entity":
						return
					wp=Bladex.GetEntity(WeaponName)
					try:
						weaponData = Reference.EntitiesObjectData[WeaponName]
					except KeyError:
						weaponData = Reference.DefaultObjectData[wp.Kind]
				
					if weaponData and len (weaponData) > 6:
						if weaponData[6][0]=="Venom":
							return	
				return
				
	Damage.CalculateDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded)
	
	
###########################################################################################################################################################
#################### Level Up Functions
AllyWeps={} 
AllyWeps["Enano1"]=["Hacha","Maza","Hacha5","Espadaromana","Orksword","Garropin","Hacha4Pro","Hacha3","Maza2","HookSword","Martillo","EgyptSword","Espadacurva","Martillo2","Garrote2","Cimitarra","MazaDoble","Hacha6","Hacha2","Martillo3"]
AllyWeps["Enano5"]=["Hacha","Maza","Hacha5","Espadaromana","Orksword","Garropin","Hacha4Pro","Hacha3","Maza2","Martillo","HookSword","Martillo2","Espadacurva","EgyptSword","Garrote2","Cimitarra","MazaDoble","Hacha6","Hacha2","Martillo3"]
AllyWeps["Dwarf_N"]=["Hacha","Maza","Hacha5","Espadaromana","Orksword","Garropin","Hacha4Pro","Hacha3","Maza2","Martillo","HookSword","Martillo2","Espadacurva","EgyptSword","Garrote2","Cimitarra","MazaDoble","Hacha6","Hacha2","Martillo3"]
AllyWeps["Knight_N"]=["Gladius","Gladius","Maza","Orksword","Espadaromana","Espadaelfica","Espadaelfica","Maza2","HookSword","LightEdge","Espadacurva","EgyptSword","Dagesse","Cimitarra","Katana","Maza3","DoubleSword","Espadafilo","Espada"]
AllyWeps["Amazon_N"]=["Bo","Bichero","Lanza","IceWand","Naginata","FireBo","Naginata","SteelFeather","Tridente","Axpear","Axpear","DeathBo","Crosspear","Crosspear","Hachacuchilla","CrushBo","Arpon","Arpon","LanzaAncha","LanzaAncha"]
AllyWeps["Barbarian_N"]=["Chaosword","Chaosword","Eclipse","DeathSword","DeathSword","IceAxe","FireBigSword","Guadanya","Alfanje","LongSword","LongSword","Hacha2hojas","FlatSword","BigSword","BigSword","RhinoClub","RhinoClub","Hacharrajada","SawSword","SawSword"]
AllyWeps["Wilf_A"]=["Hacha","Maza","Hacha5","Espadaromana","Orksword","Hacha4Pro","Espadaelfica","Hacha3","Maza2","Martillo","HookSword","Martillo2","Espadacurva","EgyptSword","Garrote2","Cimitarra","MazaDoble","Hacha6","Hacha2","Martillo3"]
AllyShields=["Escudo5","Escudo5","Escudo2","Escudo2","Escudo1","Escudo1","Escudo1","KingShield","KingShield","KingShield","Escudo8","Escudo8","Escudo9","Escudo9","Escudo3","Escudo4","Escudo4","Escudo7","Escudo6","Escudo6"]


DefaultSwordHit=[5,8,15,25,35,50,65,85,100,120,150,190,240,300,380,460,550,650,820,950]
DefaultSwordHDef=[0,-3, -5, -10, -15, -20, -25,-30, -35, -40, -45, -50, -55, -60, -65, -70,-75, -80,-85, -100]

BGDSwordHit=[8,15,25,35,50,65,85,100,120,150,190,240,300,380,460,550,650,820,950,1000]


def BlackGuardLevelUpFunc(EntityName):
	per=Bladex.GetEntity(EntityName)
	if per.Life>0:
		lvl=per.Level
		inv=per.GetInventory()
		if lvl>19:
			NEWDAMAGE=1200
			NEWDEFENSE=-120
		else:
			NEWDAMAGE=BGDSwordHit[lvl]
			NEWDEFENSE=DefaultSwordHDef[lvl]
		rwp=Bladex.GetEntity(per.InvRight)
		if rwp:
			if GiveWeaponType(EntityName)== W_FLAG_SP:
				Reference.EntitiesObjectData[rwp.Name]= [Reference.OBJ_WEAPON,5, -10, 4.0,  Reference.THR_SPINNING, [Reference.W_FLAG_SP,Reference.PI,2000,750,14000,140000,Reference.GolpeArmaEscudoMetal]]
				Reference.EntitiesObjectData[rwp.Name][1]= NEWDAMAGE
				Reference.EntitiesObjectData[rwp.Name][2]= NEWDEFENSE
				
			elif GiveWeaponType(EntityName)== W_FLAG_1H:
				# this func does not account for special damage
				Reference.EntitiesObjectData[rwp.Name]= [Reference.OBJ_WEAPON,  5, 0, 2.5,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
				Reference.EntitiesObjectData[rwp.Name][1]= NEWDAMAGE
				Reference.EntitiesObjectData[rwp.Name][2]= NEWDEFENSE
				



			
		
			
def  GetNewShield(EntityName,ShieldName):
	per=Bladex.GetEntity(EntityName)
	inv=per.GetInventory()
	nshd=Bladex.GetEntity(ShieldName)
	if inv.HoldingBow:
		# If you shot something, tough luck. No new shield
		return
	per.Wuea=Reference.WUEA_ENDED	
	per.InterruptCombat()	
	per.LaunchAnmType("Chg_l")
	inv.LinkLeftHand(ShieldName)
	per.SetOnFloor()


def  GetNewWeapon(EntityName,WeaponName):
	per=Bladex.GetEntity(EntityName)
	inv=per.GetInventory()
	nwep=Bladex.GetEntity(WeaponName)
	owep=Bladex.GetEntity(per.InvRight)
	if inv.HoldingBow:
		# If you shot something, tough luck. No new weapon
		return
	if owep:
		per.Wuea=Reference.WUEA_ENDED	
		per.InterruptCombat()	
		per.LaunchAnmType("Chg_r_l")
		inv.LinkRightHand("")
		inv.RemoveWeapon(owep.Name)
		owep.Position=0,30000,0
		inv.LinkRightHand(WeaponName)			
		per.SetOnFloor()
			
			
def IsHoldingBow(entity):	
	#per=Bladex.GetEntity(EntityName)
	inv=entity.GetInventory()
	if inv.HoldingBow:
		return 1
	return 0



def CheckNearerOpponent(EntityName):
	me=Bladex.GetEntity(EntityName) 
	x,y,z = me.Position	   
	for i in Bladex.GetEntitiesAt(x,y,z,2200):	
		ent=Bladex.GetEntity(i)
		if ent and ent.Person:
			if ent.Life>0:
				if CheckIfAlly(ent.Name)and not ent.Name=="Player1": 
					wpflag=GiveWeaponType(EntityName)
					if me.Kind=="BlackGuard_Cap" and wpflag==W_FLAG_1H:
						if Actions.IsBehindEntity(ent.Name, EntityName):
							me.SetNextAttack("GM50_1H")   # back attack
							return 1
	 	   				else:
	 	   					if ent.ActiveEnemy and ent.ActiveEnemy==EntityName:
	 	   						me.Data.SwitchOpponent(EntityName, ent.Name)
	 	   						return 1
	return 0		
			
			
			
			
Bladex.AddParticleGType("NPCLevelUpParticle","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>25:
		traux=(30.0-i)/5.0 
		aux=traux**0.5
	else:
		traux=i/25.0 
		aux=traux**2.0
	r=255
	g=255
	b=255
	a=255.0*traux
	size=200.0*aux
	Bladex.SetParticleGVal("NPCLevelUpParticle",i,r,g,b,a,size)	
			
			
			
			
###########################################################################################################################################################
########## Base Ally Class  ###############################################################################################################################

class AllyChar (PA4Ally_Def.NPCAlly):

	DeathFunc=None
	DeathArgs=()
	NPCLevelUpParticleData=[]
	LevelupFunc=None
	LevelupArgs=()
	Combatant=1
	Dusted=1
	OnGuard=0
	GuardPoint=50.0,-1000.0,50.0
	GuardLookPoint=0.0,0.0
	Agenum=0
	ThrowingObject=0
	AttackOnSight=1
	RemoveCorpseTime=0.0
	Active=0
	ChaseCount=0
	
	def __init__(self, me):
		
		PA4Ally_Def.NPCAlly.__init__(self, me)
	
		me.ImDeadFunc=self.NewImDeadFunc
		me.DamageFunc=AllyDamage
		
		self.NPCLevelUpParticleData=[]
		self.Combatant=1
		self.OnGuard=0
		self.GuardPoint=0,0,0
		self.GuardLookPoint=0,0
		self.Agenum=0
		self.ThrowingObject=0
		self.AttackOnSight=1
		self.RemoveCorpseTime=60.0
		self.Active=0
		self.ChaseCount=0
		
		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 
				aux=traux**0.5
			else:
				traux=i/25.0 
				aux=traux**2.0
			r=255
			g=255
			b=255
			a=255.0*traux
			size=200.0*aux
			self.NPCLevelUpParticleData.append(a)
			self.NPCLevelUpParticleData.append(size)
			Bladex.SetParticleGVal("NPCLevelUpParticle",i,r,g,b,a,size)
		
		self.lupsnd1=Bladex.CreateSound("..\\..\\Sounds\\aparicion-escudo.wav", "LUPSnd1")
		self.lupsnd1.Volume=0.1
		self.lupsnd1.MinDistance=10000
		self.lupsnd1.MaxDistance=30000	
		
		self.SetUnarmedDamage()
		
		#Bladex.AddScheduledFunc(Bladex.GetTime()+10.0,self.PeriodicCheck,())
		
		
	def ResetCombat (self,EntityName):		
		PA4Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttackNPCTime = 100
			
			
			
	def StdChaseFailed(self,EntityName, oldActionMode):	
		me = Bladex.GetEntity(EntityName)
		newActionMode = me.GetActionMode()
		if newActionMode == ROUTE_BOWING:
			pass
		
		elif oldActionMode == ROUTE_WATCH:
			#self.LaunchMyWatch(EntityName)
			enemy=None
			if self.MyGetEnemyName():
				enemy=Bladex.GetEntity(self.MyGetEnemyName())
			self.ChaseCount=self.ChaseCount+1
			if self.ChaseCount==10:
				
				if self.CheckForVisibleBadGuys():
					newene=Bladex.GetEntity(self.CheckForVisibleBadGuys())
					if newene.Name != enemy.Name:
						self.SwitchOpponent(EntityName, newene.Name)
					else:
						self.EnemyName=None
						me.ResetChase()
				self.ChaseCount=0
			
		
	############################# new bit ###########################
	
	
	def SwitchOpponent(self,EntityName,NewAttackerName):
		me = Bladex.GetEntity(EntityName)
		newen=Bladex.GetEntity(NewAttackerName)
		if me.ActiveEnemy and me.CanISee(newen):
			me.Wuea=Reference.WUEA_ENDED
			me.InterruptCombat()
			me.SetEnemy(newen)
			me.SetActiveEnemy(newen)
			me.Chase(newen, me.ActionAreaMax)
			if me.GetActionMode()==ROUTE_CHASE and self.IsArcher():
				self.Switch2MeleeWeapons(EntityName)
			return 1		
		return 0
	
	
	def ChooseCanISeeNearest (self, entity1name, entity2name):
		p1 = Bladex.GetEntity(entity1name)
		p2 = Bladex.GetEntity(entity2name)
		if not p1 and not p2:
			return CHOOSE_EITHER
		elif not p1:
			return CHOOSE_SECOND
		elif not p2:
			return CHOOSE_FIRST

		if p1.Life <= 0 and p2.Life <= 0:
			return CHOOSE_EITHER
		elif p1.Life <= 0:
			return CHOOSE_SECOND
		elif p2.Life <= 0:
			return CHOOSE_FIRST

		me=Bladex.GetEntity(self.Name)

		if not me.CanISee(p1) and not me.CanISee(p2) <= 0:
			return CHOOSE_EITHER
		elif not me.CanISee(p1):
			return CHOOSE_SECOND
		elif not me.CanISee(p2):
			return CHOOSE_FIRST


		val = me.SQDistance2(p1) - me.SQDistance2(p2)

		if val < 0:
			return CHOOSE_FIRST
		elif val > 0:
			return CHOOSE_SECOND
		else:
			return CHOOSE_EITHER

		
	def PeriodicCheck(self):
		me=Bladex.GetEntity(self.Name)
		if me.Life<=0 or not self.Active or self.AttackOnSight:
			return
		if not me.InCombat or me.GetActionMode()== ROUTE_CHASE:
			if self.CheckForVisibleBadGuys():
				ene=Bladex.GetEntity(self.CheckForVisibleBadGuys())
				Actions.QuickTurnToFaceEntity(self.Name,ene.Name)
				self.LookForAnotherOpponent(self.Name)
			else:
				if not self.OnGuard:
					self.LookForAnotherOpponent(self.Name)
		else:
			pass
		Bladex.AddScheduledFunc(Bladex.GetTime()+8.0,self.PeriodicCheck,())
		
		
		
		
	def CheckForVisibleBadGuys(self):
		me=Bladex.GetEntity(self.Name)
		mypos=me.Position
		localenemylist=[]
		for ename in Bladex.GetEntitiesAt(mypos[0],mypos[1],mypos[2], 20000):
                	ene=Bladex.GetEntity(ename)
                	if ene:
                		if ene.Person:
                			if ene.Life>0 and CheckIfAlly(ene.Name) and ene.Name!=me.Name and ene.Name!="Player1":
                				localenemylist.append(ene.Name)
                if len (localenemylist) == 0: 
                   	return None
		localenemylist.sort(self.ChooseCanISeeNearest)
                return localenemylist[0]
		
		
		
		
		
		
	def NewImDeadFunc (self,EntityName):
		me=Bladex.GetEntity(EntityName)
		rwp=Bladex.GetEntity(me.InvRight)
		lwp=Bladex.GetEntity(me.InvLeft)
		try:
			PA4Ally_Def.NPCAlly.StdImDead(self,EntityName)
		except:
			pass
		if self.Dusted:
			Bladex.AddScheduledFunc(Bladex.GetTime()+self.RemoveCorpseTime,RemoveMyCorpse,(EntityName,100,0,))
			if rwp:
				Reference.EntitiesSelectionData[rwp.Name]=()
				Bladex.AddScheduledFunc(Bladex.GetTime()+self.RemoveCorpseTime+3,RemoveMyWeapon,(rwp.Name,))
			if lwp:
				Reference.EntitiesSelectionData[lwp.Name]=()
				Bladex.AddScheduledFunc(Bladex.GetTime()+self.RemoveCorpseTime+6,RemoveMyWeapon,(lwp.Name,))
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
	
	
	
	def MutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		limb= Bladex.GetEntity(obj_name)
		InitDataField.Initialise(limb)
		Bladex.AddScheduledFunc(Bladex.GetTime()+20, RemoveMyWeapon,(obj_name,))
	
	
	
	def StdSeeEnemyUnreachable(self,EntityName,check1aaTo2aa=1):
		me = Bladex.GetEntity(EntityName)
	
		pass
		#if self.IsArcher():
		#	return
		#PA4Ally_Def.NPCAlly.StdSeeEnemyUnreachable(self,EntityName)
	
	
	
	

	def StdChaseFailed(self,EntityName, oldActionMode):	
		me = Bladex.GetEntity(EntityName)
		if self.IsArcher():
			return 
		if not self.LookForAnotherOpponent(EntityName):
			PA4Ally_Def.NPCAlly.StdChaseFailed(self,EntityName,oldActionMode)
	
	
	def StopAttackingNPC (self,EntityName):
		if self.AttackingNPC:
			me = Bladex.GetEntity(EntityName)
			if me and me.Life>0:
			     	ename=self.MyGetEnemyName()
			     	if ename:
					enemy = Bladex.GetEntity(ename)
					if not enemy:                                        
						Bladex.AddScheduledFunc(Bladex.GetTime() + self.AttackNPCTime, self.StopNPCsAttacking,(EntityName,))
						return
					if ename=="Player1" and self.IsArcher(): 
						return
					
					Damage.DropInvalidObjectsOnImpact (EntityName)
					me.Wuea=Reference.WUEA_ENDED
					me.InterruptCombat()
					if me.SetEnemy(enemy):
						self.AttackingNPC=FALSE
						MaxCombatDist = Bladex.GetCharType(me.CharType,me.CharTypeExt).MaxCombatDist
						if me.SQDistance2(enemy) < (MaxCombatDist*MaxCombatDist) or me.CanISee(enemy):
							me.SetActiveEnemy(enemy)
							me.Chase(enemy, me.ActionAreaMax)
							if me.GetActionMode()==ROUTE_CHASE and self.IsArcher():
								self.Switch2MeleeWeapons(EntityName)
						else:
							me.LaunchWatch()
							Damage.DropInvalidObjectsOnImpact (EntityName)
							me.Wuea=Reference.WUEA_ENDED
							me.LaunchAnmType("attack_look",1)
						self.CheckToJoin (EntityName)
					else:
						
						Bladex.AddScheduledFunc(Bladex.GetTime() + self.AttackNPCTime, self.StopNPCsAttacking,(EntityName,))
						return


		
	def LookAround90(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		inv=me.GetInventory()
		if inv.HasBow or self.OnGuard:	
			return
		trand= whrandom.randint(1,12)
		tvar=10+trand
		if self.Asleep:
			angle = me.Angle+PI*0.5
			if angle >= TWOPI:
				angle = angle - TWOPI
			me.Face(angle)
			Bladex.AddScheduledFunc(Bladex.GetTime()+ tvar, self.LookAround90,(EntityName,))
		
		
	def GetMyBowOut(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		inv= me.GetInventory()
		life = me.Life
		if life > 0.0:		
			left_type= Reference.GiveObjectFlag(me.InvLeft)
			if left_type != Reference.OBJ_BOW:
				me.SwitchToBow()
				if inv.GetSelectedWeapon() != me.InvRight and inv.GetSelectedWeapon() != me.InvLeft:
					# Launch the swap weapons animation
					out= ScorerActions.CB_WeaponOutX(EntityName,0)
					if not out:
						me.AnmEndedFunc= ScorerActions.CB_WeaponOutX
					Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, self.GetMyBowOut,(EntityName,),EntityName+"ReGetMyBowOut")

		
	
		
	def CheckDirection(self, EntityName):
		me=Bladex.GetEntity(self.Name)
		if self.OnGuard and not me.InCombat:
			Actions.TurnToFacePos(EntityName,self.GuardLookPoint[0],self.GuardLookPoint[1])
			#self.GetMyBowOut(EntityName)
		
				
	
	
	def AmIAtMyPost(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if self.OnGuard:
			gx,gy,gz=self.GuardPoint
			for pname in Bladex.GetEntitiesAt(gx,gy,gz, 1000):
				ent=Bladex.GetEntity(pname)
				if ent and ent.Person:
					if ent.Life>0:
						if ent.Name==me.Name:
							return 1
						
			return 0
	
	
	
	def GoBackToPost(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if self.OnGuard and not me.InCombat:
		
			if not self.AmIAtMyPost(EntityName):
				me.GoTo(self.GuardPoint[0],self.GuardPoint[1],self.GuardPoint[2])
				me.RouteEndedFunc=self.CheckDirection
			else:
				self.CheckDirection(EntityName)
		
		
		
	def PeriodicLook(self,EntityName):
		me=Bladex.GetEntity(EntityName)
		char=Bladex.GetEntity("Player1")
		if self.OnGuard and not me.InCombat:
			Actions.TurnToFacePos(EntityName,self.GuardLookPoint[0],self.GuardLookPoint[1])
			if not me.CaniSee(char):
				self.LookForAnotherOpponent(EntityName)
		################
		
		
	def SetGuardPoint(self):
		me=Bladex.GetEntity(self.Name)
		self.OnGuard=1
		x,y,z=me.Position
		self.GuardPoint=x,y,z
		gx,gy,gz=me.Rel2AbsPoint(0,-20000,0)
		self.GuardLookPoint=gx,gy
		
		
		
	def StdEnemyDead(self,EntityName):
		PA4Ally_Def.NPCAlly.StdEnemyDead(self,EntityName)
		me=Bladex.GetEntity(EntityName)
		newene= self.CheckForBadGuys()
		if newene and not me.InCombat:
			Actions.TurnToFaceEntity(EntityName, newene)
		else:
			if self.OnGuard:
				Bladex.AddScheduledFunc(Bladex.GetTime()+ 2.5, self.GoBackToPost,(EntityName,))
		

					
	def LookAround(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		char=Bladex.GetEntity("Player1")
		if me.RouteEndedFunc:
			me.RouteEndedFunc=None
		if me.Life>0:
			if not me.InCombat:
				if self.OnGuard and not self.CheckForBadGuys():
					self.GoBackToPost(EntityName)
				else:
					nearene=self.CheckForBadGuys()
					if nearene:
						Actions.TurnToFaceEntity(me.Name,nearene)
						if not me.CanISee(char):
							self.StdSeeTheEnemy(EntityName)
					else:
						Actions.Turn180(me.Name)
					
					
				
	def DoINeedADrink(self,EntityName):
		me=Bladex.GetEntity(EntityName)
		if me.Life>0:
			if not me.InCombat:
				PA4AllyCombat.UsePotion(EntityName)

	
	def OnKilledEnemy(self,KilledEntityName):
		KilledEntity=Bladex.GetEntity(KilledEntityName)
		if KilledEntity is None:
			return
		if KilledEntity.Name=="Player1":
			return
		me=Bladex.GetEntity(self.Name)
		
		
		Bladex.AddScheduledFunc(Bladex.GetTime()+ 4.5, self.DoINeedADrink,(self.Name,))
		me.PartialLevel=me.PartialLevel+CharStats.GetCharExperienceReward(KilledEntity.CharType,KilledEntity.Level)
		LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
		import Scorer
		if me.PartialLevel>=LevelLimit and me.Life>0:
			while me.PartialLevel>=LevelLimit:
				me.PartialLevel=me.PartialLevel-LevelLimit
				me.Level=me.Level+1
				LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
			maxlevel=CharStats.GetMaxLevel()
			maxsize=50+(140/maxlevel)*me.Level 
			maxPPS=120+(600/maxlevel)*me.Level 
			maxint=0.5+(4.5/maxlevel)*me.Level 
			AuraParams=(5, 0, 1, 0, 0, 1)
			AuraGradient=(2, 0.4, 0.6, 1.0, 0.5, 0.0, 0.1, 0.2, 1.0, 0.0, 0.8)
			AuraVar1Args=(5, maxsize, 0, 1, 0.5)
			AuraVar2Args=(maxsize, 5, 1, 0, 1.0)
			PSParams=(self.NPCLevelUpParticleData, "NPCLevelUpParticle", 30, 50, 150, 255, maxPPS, -600, 0.0, 2, 2, 0.4, 30, 0.5)
			AllyNPCLevelUpFX(me.Name, 1, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, maxint, "Timer15", 15)
			if me.Life >0: # If an enemy death by poison or trowed weapons and.. You are death!
				me.ResetWounds()
				me.Life = CharStats.GetCharMaxLife(me.Kind, me.Level)
			self.lupsnd1.Play(me.Position[0],me.Position[1],me.Position[2],0)
			if self.LevelupFunc:
				apply(self.LevelupFunc,self.LevelupArgs)
				me=Bladex.GetEntity(self.Name)
			self.SetUnarmedDamage()
				
				
				
	def SetUnarmedDamage(self):
		me=Bladex.GetEntity(self.Name)
		if not Reference.EntitiesObjectData.has_key(self.Name):
			Reference.EntitiesObjectData[self.Name]= [Reference.OBJ_WEAPON,   1,  0, 1.0,  Reference.THR_SPINNING, []]
		undam=GetUnarmedDamage(self.Name)
		Reference.EntitiesObjectData[self.Name][1]=undam
		
				
			
				
	def IsValidEnemy (self, entity):
		me=Bladex.GetEntity(self.Name)
		if not self.AttackOnSight:
			return FALSE
		if entity.Name=="Player1":
			return FALSE
		
		if not entity.Person:
			return FALSE
		if entity.Life <=0:
			return FALSE
		if entity.Name== self.Name:
			return FALSE
		if PA4AllyCombat.CheckAlly (entity.Name):
			return FALSE
		try:
			if not entity.Data.AttackOnSight or not entity.Data.Combatant:
				return FALSE
		except AttributeError:
			print entity.Name+": Is causing an Attribute Error"
			return TRUE
		
		if not me.CanISee(entity):
			return FALSE
		if IsHoldingBow(entity):
			return FALSE
		else:
			return TRUE
	

	
	def MyGetEnemyName (self):
		me=Bladex.GetEntity(self.Name)
	        if not self.EnemyName or Bladex.GetEntity(self.EnemyName).Life <=0:
                   	pjp = me.Position
		   	enemyList=[]
		   	pj_dir=me.Rel2AbsVector(0.0,-1.0,0.0)
			pjp=me.Position
			for ename in Bladex.GetEnemiesVisibleFrom(pjp,50000,pj_dir,0.0):
                       		ene=Bladex.GetEntity(ename)
                       		if self.IsValidEnemy(ene):
                         		enemyList.append(ene.Name)
                   	if len (enemyList) == 0: 
                   		self.EnemyName=None
                   		return None
                   	enemyList.sort(self.ChooseNearest)
                   	self.EnemyName=enemyList[0]
		enemy=Bladex.GetEntity(self.EnemyName)
		if self.EnemyName == "Player1": # This should not happen.....
			return None
                me.SetEnemy(enemy)
		return self.EnemyName		
	
	
	
	def StdEnterClose(self,EntityName):
		PA4Ally_Def.NPCAlly.StdEnterClose(self,EntityName)
		self.RaiseAlarm(EntityName)
	
	
	def RaiseAlarm(self,EntityName):
		# called when an ally engages an enemy. Make all other allies turn to face enemy if they are not busy....
		me=Bladex.GetEntity(EntityName)
		x,y,z=me.Rel2AbsPoint(0,2000,0)
		px,py,pz=me.Position
		for aname in Bladex.GetEntitiesAt(px,py,pz, 25000):
			ally=Bladex.GetEntity(aname)
                        if ally and ally.Person:
                		if ally.Life>0 and not ally.Blind and not CheckIfAlly(ally.Name) and ally.Name!=me.Name and ally.Name!="Player1":
                			dist=B3DLib.GetXZDistance(EntityName, ally.Name)
					if not ally.CanISee(me):
						if not ally.InCombat and not ally.Data.OnGuard and ally.Data.Combatant:
							if dist>5000 and dist <25000:
								ally.GoToJogging=1
								if ally.GetActionMode()!=PA4Ally_Def.ROUTE_CHASE:
									ally.GoTo(x,y,z)
										
							else:
								pass
							
					else:			
						Actions.TurnToFaceEntity(ally.Name,me.Name)
						ally.Data.LookForAnotherOpponent(ally.Name)
						
	
	
	
	

	def StdSeeTheEnemy(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		
		if not self.AttackOnSight:
			return 
		
		life = me.Life
		if life > 0.0:		
			if not self.MyGetEnemyName(): 
				return

			ene=Bladex.GetEntity(self.MyGetEnemyName())
			if ene:
				if self.IsValidEnemy(ene):
					#Reference.debugprint (EntityName + " I see "+ene.Name+". - I will do him over!")
					if self.Asleep:
						self.WakeMeUp(EntityName)
				me.LookAtEntity(ene.Name)
			
				#Just in case we were doing a wait animation
				if me.GetActionMode() == PA4Ally_Def.ROUTE_BAY:	
					me.Wuea=Reference.WUEA_ENDED

				#self.CheckToJoin(EntityName)
				if me.GetActionMode()!=PA4Ally_Def.ROUTE_CHASE:
					self.StdStartChase(EntityName)
				
				if me.GetActionMode()==PA4Ally_Def.ROUTE_BOWING: 
					if self.AimPressed:
						angle= Reference.TARGET_ANGLE_MAX- me.Accuracy*(Reference.TARGET_ANGLE_MAX-Reference.TARGET_ANGLE_MIN)
						if me.AimOffTarget<angle:
							#print "Releasing Arrow"
							Actions.TestReleaseArrow(EntityName)
					else: 
						if me.Wuea!=Reference.WUEA_WAIT:
							#print "Drawing Bow"
							Actions.TestDrawBow (EntityName)
				elif me.Aim or Actions.CurrentlyBowing(EntityName):
					me.Wuea=Reference.WUEA_ENDED
					Actions.EndBowMode(EntityName)
					me.SetOnFloor()
			else:
				print (EntityName + ": Cannot get a handle on me")
	
		
				

	
	def RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded):
		# launch appropriate hurt anim
		if self.Asleep:
			self.WakeMeUp(EntityName)
		
		Basic_Funcs.PlayerPerson.RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded)
		if AttackerName and AttackerName != 'BWorld' and AttackerName != EntityName:
			me = Bladex.GetEntity(EntityName)
			attacker = Bladex.GetEntity(AttackerName)
			if me and me.Life > 0:
				if not self.AttackOnSight:
					self.AttackOnSight=1
				
				#Reference.debugprint(EntityName+": Im being attacked by "+AttackerName)
				if not self.EnemyName and not me.InCombat:
					Actions.QuickTurnToFaceEntity(EntityName, AttackerName)
					self.StdSeeTheEnemy(EntityName)
					#print EntityName+" :I have been taken unawares by "+AttackerName
				
				if self.EnemyName and self.EnemyName != AttackerName:
					#Reference.debugprint(AttackerName+": Is NOT my current enemy")
					
					if attacker and CheckIfAlly(attacker.Name) and attacker.Name != "Player1": 
						if (not attacker.Data.NPC) or (not self.AttackingNPC):
							Damage.DropInvalidObjectsOnImpact (EntityName)
							me.Wuea=Reference.WUEA_ENDED
							me.InterruptCombat()
							me.SetEnemy(attacker)
							me.SetActiveEnemy(attacker)
							me.Chase(attacker, me.ActionAreaMax)
							if me.GetActionMode()==PA4Ally_Def.ROUTE_CHASE and self.IsArcher():
								self.Switch2MeleeWeapons(EntityName)		
				
				
				
	def CheckForBadGuys(self):
		me=Bladex.GetEntity(self.Name)
		mypos=me.Position
		localenemylist=[]
		for ename in Bladex.GetEntitiesAt(mypos[0],mypos[1],mypos[2], 20000):
                	ene=Bladex.GetEntity(ename)
                	if ene:
                		if ene.Person:
                			if ene.Life>0 and CheckIfAlly(ene.Name) and ene.Name!=me.Name and ene.Name!="Player1":
                				localenemylist.append(ene.Name)
                if len (localenemylist) == 0: 
                   	return None
		localenemylist.sort(self.ChooseNearest)
                return localenemylist[0]
	
	
	def ChooseNearest (self,entity1name, entity2name):
		p1 = Bladex.GetEntity(entity1name)
		p2 = Bladex.GetEntity(entity2name)
		if not p1 and not p2:
			return CHOOSE_EITHER
		elif not p1:
			return CHOOSE_SECOND
		elif not p2:
			return CHOOSE_FIRST
		me=Bladex.GetEntity(self.Name)
		val = me.SQDistance2(p1) - me.SQDistance2(p2)

		if val < 0:
			return CHOOSE_FIRST
		elif val > 0:
			return CHOOSE_SECOND
		else:
			return CHOOSE_EITHER

	

	def LookForAnotherOpponent(self,EntityName):
		
		me = Bladex.GetEntity(EntityName)
		if me.InCombat:
			return 0
		
		if (self.InvestigatingSound) or (me.GetActionMode()== PA4Ally_Def.ROUTE_SINGLE) or (me.GetActionMode()== PA4Ally_Def.ROUTE_BAY):
			return None
		
		self.LaunchMyWatch (EntityName)
		mep=me.Position
		allyenelist=[]
		ents=Bladex.GetEntitiesAt(mep[0],mep[1],mep[2], 20000)
		for ename in ents:
			en=Bladex.GetEntity(ename)
			if en.Person:
				if self.IsValidEnemy(en) and en.Name != me.Name:
					allyenelist.append(en.Name)
		if len (allyenelist) == 0: 
                   	return 0
                allyenelist.sort(self.ChooseNearest)
                nearest=Bladex.GetEntity(allyenelist[0])
                if nearest and not me.InCombat:
                	Actions.QuickTurnToFaceEntity(EntityName, nearest.Name )
                	if me.CanISee(nearest):
                		self.EnemyName=nearest.Name
                		me.Wuea=Reference.WUEA_ENDED
				me.InterruptCombat()
				me.SetEnemy(nearest)
				me.SetActiveEnemy(nearest)
				me.Chase(nearest, me.ActionAreaMax)
				return 1
			else:
				#me.GoToJogging=0
				#if me.GoTo(nearest.Position[0],nearest.Position[1],nearest.Position[2]):
				#	return 1
				pass
		return 0		
                    				
                    		
                    		
            		
	
	def StdDelayNoSeen(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me.Life > 0:
			if not self.MyGetEnemyName():
				if (not self.Asleep) and (not me.Blind):
					if me.Aim or Actions.CurrentlyBowing(EntityName):
						me.Wuea=Reference.WUEA_ENDED
						Actions.EndBowMode(EntityName)
						me.SetOnFloor()
					#Reference.debugprint(EntityName+": Im in NEWStdDelayNoSeen")
					me.StopLooking()
					self.PutMeToSleep(EntityName)
					if not self.EnemyName and self.OnGuard:
						self.ReturnToStart(EntityName)
						return
					if not self.OnGuard:
						self.LookAround(EntityName)
						
					#Reference.debugprint(EntityName+": I have got bored and dropped off to sleep")		
					
					if me.GetActionMode() != PA4Ally_Def.ROUTE_CHASE:
						if me.GetActionMode() != PA4Ally_Def.ROUTE_SINGLE and me.GetActionMode() != PA4Ally_Def.ROUTE_BAY:
							Reference.debugprint(EntityName+": I am not chasing")
							#self.LaunchMyPatrol(EntityName)
							self.LookForAnotherOpponent(EntityName)
					else:
						#Reference.debugprint(EntityName+": I am chasing")
						if me.AstarState<>PA4Ally_Def.ASTAR_SOLVED:
							# Face enemy as much as possible
							lastseenpos = me.EnemyLastSeen
							me.StartLooking(lastseenpos[0], lastseenpos[1], lastseenpos[2])
							if Actions.IsFacingPos(EntityName, lastseenpos[0], lastseenpos[2]):
								self.LaunchMyWatch (EntityName)
						else:
							Actions.TurnToFacePos(EntityName, lastseenpos[0], lastseenpos[2])
							me.RouteEndedFunc=self.LaunchMyWatch
			else:
				
				enemy=Bladex.GetEntity(self.MyGetEnemyName())
				if enemy and enemy.Life>0:
					#Reference.debugprint(EntityName+": I can't go to sleep yet, I have an enemy. It is "+enemy.Name)
					if not me.GoTo(enemy.Position[0],enemy.Position[1],enemy.Position[2]):	
						me.ResetChase()
						self.LaunchMyWatch(EntityName)
						
						
						
				
	def PutMeToSleep(self,EntityName):
		if not self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=1  
			self.Asleep = TRUE

	def WakeMeUp(self,EntityName):
		if self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=0  
			self.Asleep = FALSE
			
			
	def ReturnToStart(self,EntityName):
		me=Bladex.GetEntity(EntityName)
		me.GoTo(self.GuardPoint[0],self.GuardPoint[1],self.GuardPoint[2])
		
	

	
	def StdHearFunc(self,EntityName, SoundName, x, y, z, Volume):
		pass
		
	
	
	
	# Functions for loading and saving state
	def __getstate__(self):	
		NPCPerson_state=PA4Ally_Def.NPCAlly.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["AllyChar"]=(GameStateAux.SaveFunctionAux(self.DeathFunc),
						self.DeathArgs,
		                                GameStateAux.SaveFunctionAux(self.LevelupFunc),
		                                self.LevelupArgs,
		                                self.Combatant,
		                                self.Dusted,
		                                self.OnGuard,
		                                self.GuardPoint,
		                                self.Agenum,
		                                self.ThrowingObject,
		                                self.AttackOnSight,
		                                self.GuardLookPoint,
		                                self.RemoveCorpseTime,
		                                self.Active,
		                                self.ChaseCount)
		return NPCPerson_state
	
	def __setstate__(self,parm):
		PA4Ally_Def.NPCAlly.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["AllyChar"]
			GameStateAux.LoadFunctionAux(parms[0],self,"DeathFunc")
			self.DeathArgs=parms[1]
			GameStateAux.LoadFunctionAux(parms[2],self,"LevelupFunc")
			self.LevelupArgs=parms[3]
			self.Combatant=parms[4]
			self.Dusted=parms[5]
			self.OnGuard=parms[6]
		        self.GuardPoint=parms[7]
		        self.Agenum=parms[8]
		        self.ThrowingObject=parms[9]
		        self.AttackOnSight=parms[10]
		        self.GuardLookPoint=parms[11]
		        self.RemoveCorpseTime=parms[12]
		        self.Active=parms[13]
		        self.ChaseCount=parms[14]
		self.NPCLevelUpParticleData=[]
		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 
				aux=traux**0.5
			else:
				traux=i/25.0
				aux=traux**2.0
			r=255
			g=255
			b=255
			a=255.0*traux
			size=200.0*aux
			self.NPCLevelUpParticleData.append(a)
			self.NPCLevelUpParticleData.append(size)
		Bladex.SetParticleGVal("NPCLevelUpParticle",i,r,g,b,a,size)
				
		self.lupsnd1=Bladex.CreateSound("..\\..\\Sounds\\aparicion-escudo.wav", "LUPSnd1")
		self.lupsnd1.Volume=0.3
		self.lupsnd1.MinDistance=10000
		self.lupsnd1.MaxDistance=30000	
		
		me=Bladex.GetEntity(self.Name)
		me.ImDeadFunc=self.NewImDeadFunc
		
		
		
########################################################################################################################################################




import AniSoundBgd

class BlackGuard (AllyChar):

	def __init__(self, me):
		AllyChar.__init__(self, me)
		
		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		
		
	
	def ResetSounds(self, EntityName):
		AniSoundBgd.AsignarSonidosBgd(EntityName)
		me=Bladex.GetEntity(EntityName)
		Bladex.ReadBitMap("../../Maps/ChaosKnightMap/NUFiles/NUBlackGuardStuff/Bgd.bmp","BlackGuardIcon")
		Reference.EnemiesScorerData[self.Name]=("BlackGuardIcon","Bgd")	
		
		
		
	
	def ResetCombat (self,EntityName):		
		PA4Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 100.0
			me.BlockingPropensity = 0.7
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00
			rwp=me.InvRight
			if rwp:
				flag=Reference.GiveWeaponFlag(rwp)
				
				if flag==Reference.W_FLAG_1H:
			        	me.AttackList = BCopy.deepcopy(BlackGuard1HAttackData)
				if flag==Reference.W_FLAG_SP:
					me.AttackList = BCopy.deepcopy(BlackGuardSPAttackData)
				
			else:
				print EntityName+"_Has no weapon"
			

			
			
			
BlackGuard1HAttackData = [
           # inner zone blocks:
            [PA4AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [PA4AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [PA4AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
             # outer zone moves:
            [PA4AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [PA4AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [PA4AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [PA4AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            
            # inner zone moves:
            [PA4AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [PA4AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [PA4AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [PA4AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
           # dodges:
            [PA4AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [PA4AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [PA4AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [PA4AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
            
            [PA4AllyCombat.ATTACKDOWN, 0.90, ("STAIRS",),1200.0, 1400.0, 2500.0, 0.35],
	    #[PA4AllyCombat.ATTACK, 0.00, ("GA","GA","GA","GM1",),1200.0, 1400.0, 2500.0, 0.35],
            [PA4AllyCombat.ATTACK, 0.60, ("GA",),                0.0, 1400.0, 2500.0, 0.35],
            [PA4AllyCombat.ATTACK, 0.40, ("GA", "GA"),           1200.0, 1600.0, 2500.0, 0.35],
            [PA4AllyCombat.ATTACK, 0.10, ("GA", "GA", "GM1"),    0.0, 1600.0, 2500.0, 0.35],
            [PA4AllyCombat.ATTACK, 0.25, ("GM2",),               1200.0, 1800.0, 2500.0, 0.35],
            [PA4AllyCombat.ATTACK, 0.25, ("GM2",),               2000.0, 2250.0, 2500.0, 0.35],
	    [PA4AllyCombat.MOVE,   0.05, PA4AllyCombat.TempMoveInProc,3000.0,  7000.0, 9000.0, 0.35, 1],
            
                 
            [PA4AllyCombat.MOVE,   0.005, PA4AllyCombat.Laugh,              5000.0, 7000.0, 9000.0, 0.35, 1],
            [PA4AllyCombat.MOVE,   0.005, PA4AllyCombat.Insult,             5000.0, 7000.0, 9000.0, 0.35, 1],
            [PA4AllyCombat.MOVE,   0.02, PA4AllyCombat.GiveOrders,          5000.0, 7000.0, 9000.0, 0.35, 1],
            [PA4AllyCombat.MOVE,   0.05, PA4AllyCombat.UsePotion,           3000.0, 7000.0, 9000.0, 1.00],
]			


BlackGuardSPAttackData = [
           # inner zone blocks:
            [PA4AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [PA4AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [PA4AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
             # outer zone moves:
            [PA4AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [PA4AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [PA4AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [PA4AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            
            # inner zone moves:
            [PA4AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [PA4AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [PA4AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [PA4AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [PA4AllyCombat.ATTACK, 0.40, ("GI_SP","GI_SP",) ,1500.0, 2200.0, 3000.0, 0.35],
            #[PA4AllyCombat.ATTACK, 0.50, ("GI_SP",) ,0.0, 1000.0, 1800.0, 0.35],
	    [PA4AllyCombat.ATTACK, 0.25, ("GM1_SP",),1500.0, 1800.0, 2500.0, 0.35], 
	    [PA4AllyCombat.ATTACK, 0.25, ("GM8_SP",),1500.0, 1800.0, 2500.0, 0.35], 
	    [PA4AllyCombat.ATTACK, 0.25, ("GM6_SP",),1500.0, 1800.0, 2500.0, 0.35], 
	    [PA4AllyCombat.ATTACK, 0.15, ("GM3_SP",),1500.0, 1800.0, 2500.0, 0.35], 
	    
	    #[PA4AllyCombat.MOVE,   0.005, PA4AllyCombat.Laugh,              5000.0, 7000.0, 9000.0, 0.35, 1],
	    [PA4AllyCombat.MOVE,   0.05, PA4AllyCombat.TempMoveInProc,      5000.0, 7000.0, 9000.0, 0.35],
            
           # dodges:
            [PA4AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [PA4AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [PA4AllyCombat.DODGE,  0.50, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [PA4AllyCombat.ATTACK, 0.30, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
            [PA4AllyCombat.MOVE,   0.05, PA4AllyCombat.UsePotion,   3000.0, 7000.0, 9000.0, 1.00],
]		



			

############################################################################################################################################################
######## Half-Orcs

"""
import AniSoundHalforc

class Halforc (AllyChar):
	def __init__(self, me):
		AllyChar.__init__(self, me)
		
		
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		
		
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if me.MeshName=="Halforc_A":
			AniSoundHalforc.AsignarSonidosHalforc(EntityName)
			Bladex.ReadBitMap("../../Maps/PeasantsRevolt/NUFiles/NUHalforcStuff/Halforc_AIcon.bmp","Halforc_AIcon")
			Reference.EnemiesScorerData[self.Name]=("Halforc_AIcon","Hok")
		else:
			AniSoundHalforc.AsignarSonidosHalforc(EntityName)
			Bladex.ReadBitMap("../../Maps/PeasantsRevolt/NUFiles/NUHalforcStuff/Halforc_BIcon.bmp","Halforc_BIcon")
			Reference.EnemiesScorerData[self.Name]=("Halforc_BIcon","Hok")



	def ResetCombat (self,EntityName):
		AllyChar.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			if me.Kind=="Halforc_A":
				me.AttackList = BCopy.deepcopy(HalforcAttackData)
				me.BlockingPropensity = 0.5
			else:
				me.AttackList = BCopy.deepcopy(HalforcAttackData)
				me.BlockingPropensity = 0.5
			self.ChanceOfFuryOnHurt = 0.45	
			



HalforcAttackData =	[ 
           # inner zone blocks:
            [PA4AllyCombat.BLOCK,  0.25, (),                   500.0, 1000.0, 3000.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.05, "tf",                 750.0, 1500.0, 3500.0, 0.50],
           # total inner zone 0.45
           
           # outer zone blocks:
            [PA4AllyCombat.BLOCK,  0.07, (),                  3000.0, 4000.0, 5000.0, 0.50],
            [PA4AllyCombat.BLOCK,  0.035,"tr",                3500.0, 7000.0, 9000.0, 0.50,1],
            [PA4AllyCombat.BLOCK,  0.035,"tl",                3500.0, 7000.0, 9000.0, 0.50,1],
            [PA4AllyCombat.BLOCK,  0.245,"tb",                3500.0, 7000.0, 9000.0, 0.50,1],
            [PA4AllyCombat.BLOCK,  0.07, "tf",                3500.0, 7000.0, 9000.0, 0.50,1],
           # total outer zone 0.455
           
           # dodges:
            [PA4AllyCombat.DODGE,  0.30, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [PA4AllyCombat.DODGE,  0.30, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [PA4AllyCombat.DODGE,  0.30, "d_b",                500.0, 1200.0, 2800.0, 0.35],

           # attacks:
            [PA4AllyCombat.ATTACKDOWN, 1.00, ("STAIRS",),         1200.0, 1800.0, 2500.0, 0.35],

            [PA4AllyCombat.ATTACK, 0.50, ("g_01",),            765.0, 2397.5, 3265.0, 0.35],
            [PA4AllyCombat.ATTACK, 0.40, ("g_02",),            873.0, 2123.0, 3373.0, 0.35],
            [PA4AllyCombat.ATTACK, 0.40, ("g_06",),            764.0, 2014.0, 3264.0, 0.35],
            [PA4AllyCombat.ATTACK, 0.20, ("g_15",),            844.0, 2094.0, 3344.0, 0.35],
            #[PA4AllyCombat.ATTACK, 0.20, ("g_16",),            243.0, 1493.0, 2743.0, 0.35],
            [PA4AllyCombat.ATTACK, 0.15, ("g_18",),           1917.0, 3167.0, 4417.0, 0.35], 
            
            [PA4AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1200.0, 1.00,1],
            
            # combinations
            [PA4AllyCombat.ATTACK, 0.40, ("COMBO1",),            764.0, 2014.0, 3264.0, 0.35],
            [PA4AllyCombat.ATTACK, 0.40, ("COMBO2",),            243.0, 1493.0, 2743.0, 0.35],
            [PA4AllyCombat.ATTACK, 0.40, ("COMBO3",),            873.0, 2123.0, 3000.0, 0.35],

           # inner zone moves:
            [PA4AllyCombat.MOVE,   0.03, "tr",                   0.0, 2000.0, 5000.0, 0.50],
            [PA4AllyCombat.MOVE,   0.03, "tl",                   0.0, 2000.0, 5000.0, 0.50],
            [PA4AllyCombat.MOVE,   0.05, "tb",                   0.0, 2000.0, 5000.0, 0.50],
            [PA4AllyCombat.MOVE,   0.10, "tf",                   0.0, 2000.0, 5000.0, 0.50],

           # outer zone moves:
            [PA4AllyCombat.MOVE,   0.03, "tr",                5000.0, 7000.0, 9000.0, 0.50,1],
            [PA4AllyCombat.MOVE,   0.03, "tl",                5000.0, 7000.0, 9000.0, 0.50,1],
            [PA4AllyCombat.MOVE,   0.05, "tb",                5000.0, 7000.0, 9000.0, 0.50,1],
            [PA4AllyCombat.MOVE,   0.03, "tf",                5000.0, 7000.0, 9000.0, 0.50,1],
            #[PA4AllyCombat.MOVE,   0.15, PA4AllyCombat.TempMoveInProc,      5000.0, 7000.0, 9000.0, 0.35,1],
            [PA4AllyCombat.MOVE,   0.05, PA4AllyCombat.UsePotion,           3000.0, 7000.0, 9000.0, 1.00],
]


"""



############################################################################################################################################################
######### Static Archers






import BInput

def InitBowing(EntityName):
	me= Bladex.GetEntity(EntityName)
	me.Returns= 0
	me.Aim= 1
	me.Data.AimPressed= 1
	me.Accuracy= me.Data.Accuracy
	me.AimOffTarget= TWOPI
	
	
def TestDrawBow(EntityName):
	me= Bladex.GetEntity(EntityName)
	if me.Aim==0 or not Actions.CurrentlyBowing(EntityName):
		if me.InvLeft and Reference.GiveObjectFlag(me.InvLeft)==Reference.OBJ_BOW:
			# check we can interrupt the animation
			if me.Wuea==Reference.WUEA_WAIT:
				if (me.AnimName[:3]=="Rlx" or me.AnimName[:3]=="rlx"):
					me.Wuea=Reference.WUEA_NONE
				else: return
			# Are we carrying an arrow
			if me.InvRight and Reference.GiveObjectFlag(me.InvRight)==Reference.OBJ_ARROW:
				InitBowing(EntityName)
				Actions.GraspString (EntityName,"GraspString")
				me.SetTmpAnmFlags(1,0,1,1,2,0)
				me.LaunchAnmType ("b1")
				arrow= Bladex.GetEntity(me.InvRight)
				tensar_sound=Bladex.CreateEntity(arrow.Name+"RedrawSound", "Entity Sound", 0, 0, 0)
				tensar_sound.SetSound("..\\..\\Sounds\\M-CREAKCUERDA-3b.wav")
				tensar_sound.MinDistance=5000
				tensar_sound.MaxDistance=10000
				arrow.Link(tensar_sound)
			
			elif not Actions.CurrentlyBowing(EntityName):
				inv=me.GetInventory()
				des_quiver_name=inv.GetSelectedQuiver()
				if des_quiver_name:
					inv.SetCurrentQuiver(des_quiver_name)
					inv.LinkRightBack(des_quiver_name)
					quiver= Bladex.GetEntity(des_quiver_name)
					if quiver and quiver.Data.NumberOfArrows() > 0:
						InitBowing(EntityName)
						if me.Wuea==Reference.WUEA_WAIT:
							print "Trying to draw bow during other animation, wait and try again"
						else:
							me.LaunchAnmType ("b2")



def TestReleaseArrow(EntityName):
	me= Bladex.GetEntity(EntityName)
	me.Data.AimPressed= 0
	if not Actions.CurrentlyBowing(EntityName):
		EndBowMode(EntityName)




def EndBowMode(EntityName):
	me= Bladex.GetEntity(EntityName)
	me.Aim= 0
	me.Data.AimPressed= 0




def EndDrawBowEventHandlerX(EntityName):
	me= Bladex.GetEntity(EntityName)
	
	if me.Data.AimPressed==0:
		me.Aim= 0
		arrow= Bladex.GetEntity(me.InvRight)
		if arrow:
			
			me.Unlink(arrow)
			me.RemoveFromInventRight()
			Actions.UnGraspString (EntityName,"UnGraspString")
			arrow.ExcludeHitFor(me)
			arrow.PutToWorld()
			vx,vy,vz= me.AimVector
			vx2=vx
			vy2=vy-5000
			vz2=vz
			arrow.Fly(vx2,vy2,vz2)

			arrow.MessageEvent(Actions.MESSAGE_START_WEAPON,0,0)
			arrow.MessageEvent(Actions.MESSAGE_START_TRAIL,0,0)

			# Arrange for the MESSAGE_STOP_WEAPON to be sent
			InitDataField.Initialise(arrow)
			Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, Actions.ThrownWeaponStopFunc,(arrow.Name,),"Stop Weapon: "+arrow.Name)
			arrow.Data.PrevInflictHitFunc= arrow.InflictHitFunc
			arrow.InflictHitFunc= Actions.ThrownWeaponInflictHitFunc
			arrow.Data.ThrownBy= me

			soltar_sound=Bladex.CreateEntity(arrow.Name+"FlySound", "Entity Sound", 0, 0, 0)
			soltar_sound.SetSound("..\\..\\Sounds\\ARCO-DISPARO-3.wav")
			soltar_sound.MinDistance=5000
			soltar_sound.MaxDistance=10000
			arrow.Link(soltar_sound)
			soltar_sound.PlaySound(0)
			
			me.SetTmpAnmFlags(1,0,1,1,2,0)
			me.LaunchAnmType ("b2")
			return
	me.LaunchAnmType ("b3")


def CheckRefireBowEventHandlerX(EntityName):
	me= Bladex.GetEntity(EntityName)
	
	if me.InvRight:
		action= BInput.GetInputManager().GetInputActions().Find("Attack")
		if action and action.this!="NULL" and action.CurrentlyActivated():
			me.Aim= 1
			me.Data.AimPressed= 1

		if me.Data.AimPressed:
			arrow= Bladex.GetEntity(me.InvRight)
			if arrow:
				
				Actions.GraspString (EntityName,"GraspString")
				me.DoActionWI ("b1", Actions.FixedFootAutoInterp, 0.3, 0.9)
				tensar_sound=Bladex.CreateEntity(arrow.Name+"RedrawSound", "Entity Sound", 0, 0, 0)
				tensar_sound.SetSound("..\\..\\Sounds\\M-CREAKCUERDA-44.wav")
				tensar_sound.MinDistance=5000
				tensar_sound.MaxDistance=10000
				arrow.Link(tensar_sound)
				tensar_sound.PlaySound(0)
				return
	EndBowMode(EntityName)


## Is This Used?
def EndReloadBowEventHandler(EntityName, EventName):
	
	me= Bladex.GetEntity(EntityName)
	if me.Aim:
		me.DoAction ("b1")
	else:
		if not me.InvRight:
			TakeArrowEventHandler(EntityName, EventName)
		me.LaunchAnmType ("Rlx_b")
		



def StaticArcherDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded):
	if VictimName:
		vict=Bladex.GetEntity(VictimName)
		if WeaponName:
			wp=Bladex.GetEntity(WeaponName)
			if wp.Kind=="Canica":
				vict.Life=0
		return


########################################################################################

class AllyArcher (AllyChar):


	WatchPoint=0,0
	GoPos=0,0,0
	GoAng=0
	Accuracy=0.98
	EnemyRaces=["Knight_Traitor"]
	StuckCounter=0

	def __init__(self, me):
		
		AllyChar.__init__(self, me)

		
		x,y,z= me.Rel2AbsPoint(0,-20000,0)
		self.WatchPoint= x,y
		self.GoPos=0,0,0
		self.GoAng=0
		self.Accuracy=0.9
		self.EnemyRaces=["Knight_Traitor"]
		self.StuckCounter=0
		#me.ImHurtFunc=self.ArcherImHurt #######
		#me.DamageFunc=StaticArcherDamage
		
		me.AddAnmEventFunc("TakeArrow", self.TakeArrowEventHandler)
		me.AddAnmEventFunc("CheckRefireBow", self.CheckRefireBowEventHandler)
		
		me.AddAnmEventFunc("GraspString", self.GraspString)
		me.AddAnmEventFunc("UnGraspString",self.UnGraspString)
		
		
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		Bladex.ReadBitMap("../../Maps/ChaosKnightMap/NUFiles/NUBlackGuardArcherStuff/BGarcherIcon.bmp","BGarcherIcon")
		Reference.EnemiesScorerData[self.Name]=("BGarcherIcon","Bga")
		
		
		
		
	def PeriodicArcherCheck(self):
		me = Bladex.GetEntity(self.Name)
		char=Bladex.GetEntity("Player1")
		#print self.Name+" :Check"
		if me.Life>0:
			me.SetOnFloor()
			if not Actions.CurrentlyBowing(self.Name) and me.AnimName[0:3]=="rlx" or me.AnimName[0:3]=="Rlx":
				Actions.TurnToFacePos(self.Name, self.WatchPoint[0], self.WatchPoint[1])
			if not me.CanISee(char) or not self.EnemyName:
				self.LookForNewEnemy(self.Name)
				#print self.Name+" :Look for new enemy"
		Bladex.AddScheduledFunc(Bladex.GetTime()+10.0,self.PeriodicArcherCheck,())



	def CheckRefireBowEventHandler(self, EntityName, EventName):
		CheckRefireBowEventHandlerX(EntityName)
		
			
		
	def GraspString (self,EntityName,EventName):
		me= Bladex.GetEntity(EntityName)
		if me:
			inv= me.GetInventory()
			if inv:
				if inv.HoldingBow:
					bow= Bladex.GetEntity(inv.GetBow())
					try: 
						bow.Data.GraspString()
					except AttributeError: 
						print "No string on bow. "	
		
		
	def UnGraspString (self, EntityName,EventName):
		me= Bladex.GetEntity(EntityName)
		if me:
			inv= me.GetInventory()
			if inv:
				if inv.HoldingBow:
					bow= Bladex.GetEntity(inv.GetBow())
					try: 
						bow.Data.UnGraspString()
					except AttributeError: 
						print "No string on bow."


	def TakeArrowEventHandler(self, EntityName, EventName):
		me= Bladex.GetEntity(EntityName)
		if me:
			inv= me.GetInventory()
			Actions.UnSheatheArrow(inv)
						
						
	def ResetCombat (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			me.CombatDistFlag = 1
			me.AttackList = []
			self.ChanceOfFuryOnHurt = 0.45


	def SetWatchPoint(self):
		me = Bladex.GetEntity(self.Name)
		x,y,z= me.Rel2AbsPoint(0,-20000,0)
		self.WatchPoint= x,z
		Actions.TurnToFacePos(self.Name,x,y)
	

	def Deploy(self, attflag=0):
		me=Bladex.GetEntity(self.Name)
		me.Position=self.GoPos[0],self.GoPos[1],self.GoPos[2]
		me.Angle=self.GoAng
		me.UnFreeze()
		me.SetOnFloor()
		self.AttackOnSight=attflag
		self.StdEnterLarge(me.Name)
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.5,self.SetWatchPoint,())
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.5,self.PeriodicArcherCheck,())
			
				
	
	def ToolUp(self, BowType = "Arco", QuiverType = "Carcaj"):
		# he needs a 1H wep even if he never uses it
		me=Bladex.GetEntity(self.Name)
		inv=me.GetInventory()
		swd=Bladex.CreateEntity(self.Name+"WP", "Garrote",0,0,0,"Weapon")
		inv.AddWeapon(swd.Name)
		bw=Bladex.CreateEntity(self.Name+"BW", BowType ,0,0,0,"Weapon")
		ItemTypes.ItemDefaultFuncs(bw)
		inv.AddBow(bw.Name)
		qv=Bladex.CreateEntity(self.Name+"Qv", QuiverType ,0,0,0,"Weapon")
		
		QuiverTypes.QuiverTypeFuncs(qv)
		qv.Data.ArrowsLeft=3
		inv.AddQuiver(qv.Name)
		self.WeaponsOut(self.Name)


	def RemoveMe(self):
		me=Bladex.GetEntity(self.Name)
		me.Freeze()
		me.Position=0,20000,0
		


	def ArcherImHurt(self,EntityName):
		Reference.debugprint(EntityName+": Oh! That hurt a lot.")
		me = Bladex.GetEntity(EntityName)
		pass		

	

	
	def CheckForBadGuys(self):
		me=Bladex.GetEntity(self.Name)
		char=Bladex.GetEntity("Player1")
		mypos=me.Position
		localenemylist=[]
		
		pjp = me.Position
		pj_dir=me.Rel2AbsVector(0.0,-1.0,0.0)
		
		for ename in Bladex.GetEnemiesVisibleFrom(pjp,30000,pj_dir,0.0):
                       	ene=Bladex.GetEntity(ename)
                       	if ene:
                		if ene.Person:
                			if self.IsValidEnemy(ene):  
                				localenemylist.append(ene.Name)
                				#print ene.Name+" : on target list"
               
		if char.Name in localenemylist:
                	localenemylist.remove(char.Name)
                if len (localenemylist) == 0: 
                	print "No Enemies"
                   	return None
                
		localenemylist.sort(self.ChooseCanISeeNearest)
                return localenemylist[0]
	
                
        
                
	
                

        def LookForNewEnemy(self, EntityName):
        	me=Bladex.GetEntity(EntityName)
        	
        	if self.CheckForBadGuys():
        		possene=Bladex.GetEntity(self.CheckForBadGuys())
        		if self.EnemyName:
        			currene=Bladex.GetEntity(self.EnemyName) 
        			if not me.CanISee(currene):
        				self.EnemyName=None
        				me.Wuea=Reference.WUEA_ENDED
					me.InterruptCombat()
        				me.ResetChase()
        		if me.CanISee(possene):
        			self.EnemyName=possene.Name
        			me.Wuea=Reference.WUEA_ENDED
				me.InterruptCombat()
				me.SetEnemy(possene)
				me.SetActiveEnemy(possene)
				if me.GetActionMode()!=PA4Ally_Def.ROUTE_CHASE:
					self.StdStartChase(EntityName)	
				
				return TRUE
		return FALSE




	def IsValidEnemy (self, entity):
		me=Bladex.GetEntity(self.Name)
		if not self.AttackOnSight:
			return FALSE
		if entity.Name == "Player1": 
			return FALSE
		if not entity.Person: 
			return FALSE
		if not entity.Life > 0:
			return FALSE
		if entity.Name == self.Name:
			return FALSE
		if entity.Kind==me.Kind:
			return FALSE
		try:
			if not entity.Data.Combatant:
				return FALSE
		except AttributeError:
			return TRUE
		
		if  entity.Kind in self.EnemyRaces: 
			return TRUE
		else:
			return FALSE	




	def MyGetEnemyName (self):
		me=Bladex.GetEntity(self.Name)
		char=Bladex.GetEntity("Player1")
		if not self.AttackOnSight:
                   	return None
                try:
                	if self.EnemyName and Bladex.GetEntity(self.EnemyName).Life <=0:
                		return None   	
                except AttributeError:
                	print self.EnemyName+" : is to blame"
                	return None  
                	
                	
	        if not self.EnemyName:
	        
                   	pjp = me.Position
		   	enemyList=[]
		   	pj_dir=me.Rel2AbsVector(0.0,-1.0,0.0)
			
			for ename in Bladex.GetEnemiesVisibleFrom(pjp,40000,pj_dir,0.0):
				ene=Bladex.GetEntity(ename)
				if ene.Person:
					if self.IsValidEnemy(ene):
                         			enemyList.append(ene.Name)
                        #if me.CanISee(char):
                        #	enemyList.append("Player1")
                         		
                   	if len(enemyList) == 0:
                   		return None
                   	enemyList.sort(self.ChooseCanISeeNearest)
                   	self.EnemyName=enemyList[0]
                   	
		enemy=Bladex.GetEntity(self.EnemyName)
		if enemy.Name== "Player1":
			print "Why am I shooting at the Boss????"
			
                me.SetEnemy(enemy)
		return self.EnemyName						
			
			
	


	def StdSeeTheEnemy(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if not self.AttackOnSight:
			return 
		
		if me.Life > 0.0:		
			if not self.MyGetEnemyName(): 
				return
			#Reference.debugprint (EntityName + ": I spy an Enemy")
			ene=Bladex.GetEntity(self.MyGetEnemyName())
			if ene:
				if self.IsValidEnemy(ene):
					#Reference.debugprint (EntityName + ": Your Name is "+ene.Name+ " I will shoot you")
					if self.Asleep:
						self.WakeMeUp(EntityName)
				me.LookAtEntity(ene.Name)
				#Just in case we were doing a wait animation
				if me.GetActionMode() == PA4Ally_Def.ROUTE_BAY:	
					me.Wuea=Reference.WUEA_ENDED

				
				if me.GetActionMode()!=PA4Ally_Def.ROUTE_CHASE:
					self.StdStartChase(EntityName)
				
				if me.GetActionMode()==PA4Ally_Def.ROUTE_BOWING: 
					if self.AimPressed:
						angle= Reference.TARGET_ANGLE_MAX- self.Accuracy*(Reference.TARGET_ANGLE_MAX-Reference.TARGET_ANGLE_MIN)
						if me.AimOffTarget<angle:
							#print EntityName+" Releasing Arrow"
							TestReleaseArrow(EntityName)
					else: 
						if me.Wuea!=Reference.WUEA_WAIT:
							#print EntityName+" Drawing Bow"
							TestDrawBow(EntityName)
							
				elif me.Aim or Actions.CurrentlyBowing(EntityName):
					me.Wuea=Reference.WUEA_ENDED
					#Actions.EndBowMode(EntityName)#################################
					EndBowMode(EntityName)
					print EntityName+" End Bow Mode"
					me.SetOnFloor()
				else:
					if me.GetActionMode() == PA4Ally_Def.ROUTE_WATCH:
						self.StuckCounter=self.StuckCounter+1
						if self.StuckCounter>10:
							print EntityName+" STUCK"
							self.StuckCounter=0
							me.Wuea=Reference.WUEA_ENDED
							me.InterruptCombat()
							me.ResetChase()




	def StdStartChase(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		
		me.AnmEndedFunc=self.StdAnmEnded
		if not self.EnemyName:
			return
		
		enemy=Bladex.GetEntity(self.EnemyName)
		
		if me.CanISee(enemy):
			self.StdStartChase2 (EntityName)
		else:
			self.LookForNewEnemy(EntityName)
			
		
		


	def StdStartChase2(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		#enemy=Bladex.GetEntity(me.GetEnemyName())
		if not self.EnemyName:
			print EntityName+" :I want to chase but I have no enemy"
			return
		
		
		enemy=Bladex.GetEntity(self.EnemyName)#####
		
		oldActionMode = me.GetActionMode()		
		if (oldActionMode == ROUTE_WATCH) or (oldActionMode == ROUTE_BOWING):
			
			me.RouteEndedFunc=self.StdRouteEnded
		if oldActionMode == ROUTE_CHASE:
			#print EntityName+" :Old action mode was Route Chase"
			pass
		else:
			self.ResetCombat(EntityName)
			last_time_seen=me.LastTimeSeen       #Note that the "Chase" function updates the LastSeenTime!
			me.Chase(enemy, me.ActionAreaMax)
			
			
		
	def LaunchMyWatch(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me and me.Life > 0:
			if self.EnemyName:
				enemy=Bladex.GetEntity(self.EnemyName)
				if not enemy or not me.CanISee(enemy):
					me.StopLooking()
			me.LaunchWatch()
		
		
		
			
			
	def StdDelayNoSeen(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		char=Bladex.GetEntity("Player1")
		if me.Life > 0:
			if (not self.Asleep) and (not me.Blind):
				if me.Aim or Actions.CurrentlyBowing(EntityName):
					me.Wuea=Reference.WUEA_ENDED
					Actions.EndBowMode(EntityName)
					me.SetOnFloor()
				#print EntityName+" ;I am bored now"
				if not me.CanISee(char): 
					self.EnemyName=None
					self.LookForNewEnemy(self.Name)
				
				

	def StdEnemyDead(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		self.EnemyName=None
		Reference.debugprint(EntityName+": My enemy is dead.He heheheheheeee! - py")
		char=Bladex.GetEntity("Player1")
		if self.CheckForBadGuys():
			
			Bladex.AddScheduledFunc(Bladex.GetTime()+0.5,self.LookForNewEnemy,(EntityName,))								
		else:
			pass
			
			
	def OnKilledEnemy(self,KilledEntityName):
		print "Enemy Leveling up"
		KilledEntity=Bladex.GetEntity(KilledEntityName)
		if KilledEntity is None:
			return
		if KilledEntityName == "Player1":
			print self.Name+": I have killed the Player and got promotion"
			self.Champion =1
			self.FastrackLevelUp()
			return
		me=Bladex.GetEntity(self.Name)
		
		me.PartialLevel=me.PartialLevel+CharStats.GetCharExperienceReward(KilledEntity.CharType,KilledEntity.Level)
		LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
		if me.PartialLevel>=LevelLimit and me.Life>0:
			while me.PartialLevel>=LevelLimit:
				me.PartialLevel=me.PartialLevel-LevelLimit
				me.Level=me.Level+1
				LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
			maxlevel=CharStats.GetMaxLevel()
			maxsize=50+(140/maxlevel)*me.Level 
			maxPPS=120+(600/maxlevel)*me.Level 
			maxint=0.5+(4.5/maxlevel)*me.Level 
			AuraParams=(5, 0, 1, 0, 0, 1)
			AuraGradient=(2, 0.4, 0.6, 1.0, 0.5, 0.0, 0.1, 0.2, 1.0, 0.0, 0.8)
			AuraVar1Args=(5, maxsize, 0, 1, 0.5)
			AuraVar2Args=(maxsize, 5, 1, 0, 1.0)
			print "Levelup PS params set"
			PSParams=(self.NPCLevelUpParticleData, "NPCLevelUpParticle", 30, 50, 150, 255, maxPPS, -600, 0.0, 2, 2, 0.4, 30, 0.5)
			AllyNPCLevelUpFX(me.Name, 1, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, maxint, "Timer15", 15)
			if me.Life >0: # If an enemy death by poison or trowed weapons and.. You are death!
				me.ResetWounds()
				me.Life = CharStats.GetCharMaxLife(me.Kind, me.Level)
			self.lupsnd1.Play(me.Position[0],me.Position[1],me.Position[2],0)
			if self.LevelupFunc:
				apply(self.LevelupFunc,self.LevelupArgs)
						
			
					
	# functions that need disabling
		
	def StdHearFunc(self,EntityName, SoundName, x, y, z, Volume):
		me = Bladex.GetEntity(EntityName)
		pass


	def StdEnterClose(self,EntityName):
		Reference.debugprint(EntityName+": I am entering close combat")
		pass
		
		
		
	def Switch2MeleeWeapons(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		pass
		

	def CheckGoodGroupFormation(self,EntityName, include_me):
		me = Bladex.GetEntity(EntityName)
		pass



							
					



	def __getstate__(self):
		NPCPerson_state=EnemyChar.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["RangerArcher"]=(self.WatchPoint,
						    self.GoPos,
	                                            self.GoAng,
	                                            self.Accuracy,
	                                            self.EnemyRaces,
	                                            self.StuckCounter)
						   
		return NPCPerson_state
	
	def __setstate__(self,parm):
		EnemyChar.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["RangerArcher"]
			self.WatchPoint=parms[0]
		        self.GoPos=parms[1]
	                self.GoAng=parms[2]
			self.Accuracy=parms[3]
			self.EnemyRaces=parms[4]
			self.StuckCounter=parms[5]
		me=Bladex.GetEntity(self.Name)
		me.AddAnmEventFunc("TakeArrow", self.TakeArrowEventHandler)
		me.AddAnmEventFunc("CheckRefireBow", self.CheckRefireBowEventHandler)
		
		me.AddAnmEventFunc("GraspString", self.GraspString)
		me.AddAnmEventFunc("UnGraspString",self.UnGraspString)













