import Bladex
import GameText
import AuxFuncs
import Reference
import Scorer
import Breakings
import ItemTypes
import Actions
import darfuncs
import B3DLib
import whrandom


import NPCStats

GameText.MapList ['CHAOSKNIGHTMAP'] = 'ChaosKnightMap'






##########################################################################################################################################################
###### Init Player key bindings, calibrate Scorer and all that stuff.............

cam=Bladex.GetEntity("Camera")
char=Bladex.GetEntity("Player1")

	
AttackPhase=1

LiveGame=1


def SetCamSave():
	global LiveGame
	if LiveGame==1:
		LiveGame=0
	else:
  		cam.PViewType=0
		print "Setting cam PV in saved game"

Bladex.AddScheduledFunc(Bladex.GetTime() + 2.0,SetCamSave,())


def ResetAttackMoves():

	# To fix bug in savegame where Data is applied before 
	# weapons are added to inventory and
	# unarmed moves are enabled.
	ents = Bladex.nEntities()
	for id in range(ents):
		per = Bladex.GetEntity(id)
		if per: 
			if per.Person:
				if per.Life>0 and per.Name!="Player1":
					try:
						per.Data.ResetCombat(per.Name)
						Reference.debugprint("RESET COMBAT: " + per.Name)
					except AttributeError:
						Reference.debugprint(per.Name+": Does not have ResetCombat attribute")

Bladex.AddScheduledFunc(Bladex.GetTime() + 3.0, ResetAttackMoves, ())





def InitExtraStuff():
	import ChaosKnight_XTypes
	ChaosKnight_XTypes.RemapKeys()
	
	
	
	
		
Bladex.AddScheduledFunc(Bladex.GetTime()+ 2.5, InitExtraStuff,())


################################################################################################################################################################################################


EnemyDeadCount=0
AllyDeadCount=0
PlayerDeaths=0



import counter


def BlackGuardDead(entity):
	global AlliesActive
	
	if entity in AlliesActive:
		AlliesActive.remove(entity)
		GoodGuyDead()
		print entity+" is deaded"
	else:
		print entity+" :killed twice?"

def ClimberDead(entity):
	global EnemyDeadCount
	global numclimbers
	EnemyDeadCount=EnemyDeadCount+1
	UpdateCasualtyList()
	numclimbers=numclimbers-1

def BadGuyDead():
	global EnemyDeadCount
	EnemyDeadCount=EnemyDeadCount+1
	UpdateCasualtyList()
	
	
def GoodGuyDead():
	global AllyDeadCount
	AllyDeadCount=AllyDeadCount+1
	UpdateCasualtyList()
	if AllyDeadCount == 4:
		print "Guard group one all dead -> open door"
		Bladex.AddScheduledFunc(Bladex.GetTime() + 10.0,ActReserves1,())
	if AllyDeadCount == 8:
		print "Reserves all killed -"
		
		
		
		

def UpdateCasualtyList():
	counter.WriteDeadCountText(EnemyDeadCount,AllyDeadCount,PlayerDeaths)
	





################################################################################################################################################################################################
#### Start


def Intro():
	char.Position=434,-1449,-7599  #153,-1463,-21726
	char.Angle=0.0
  	cam.PViewType=0
	Bladex.DeactivateInput()
	AuxFuncs.FadeFrom(3.0,0.6)
	Bladex.AddScheduledFunc(Bladex.GetTime() + 3.0,Bladex.ActivateInput,())
	Bladex.AddScheduledFunc(Bladex.GetTime() + 3.0,Scorer.SetVisible,(1,))
	Bladex.AddScheduledFunc(Bladex.GetTime() + 3.0, UpdateCasualtyList,())
	char.Data.SetCKWeaponDamage()
	Bladex.AddScheduledFunc(Bladex.GetTime() + 7.0, StartMusic,())
	
def StartMusic():
	Bladex.ExeMusicEvent(Bladex.GetMusicEvent("Theme1"))	
	print "Music on"

	
	
	

################################################################################################################################################################################################
########### EnemyGenerator


import EnemyCharTypes



def SignOn(entity):
	char.Data.AddAlly(entity)
	
	




Enemynum=0
EnemyActive=0
AttackNum=0


	
def StartAttack(sector, entity):
	
	if entity != "Player1":
		return
	print "sector1"
	if EnemyActive: 
			return
	ActivateNextAttack()
	ActArchers()
	sect1.OnEnter = ""
	
	
	
def ActivateNextAttack():
	print "Start Attack"
	global AttackNum
	global EnemyActive
	if AttackNum == 0:
		CurrentEnemyList.append("StartWarTroll")
		darfuncs.UnhideBadGuy("StartWarTroll")
		door1.OpenDoor()
		Bladex.AddScheduledFunc(Bladex.GetTime()+8.0, Advance,("StartWarTroll",))
		Bladex.AddScheduledFunc(Bladex.GetTime()+12.0,CloseBridgeDoor,())
		EnemyActive=1
		AttackNum = 1
		sk1.Position= 1681,1800,47417
		sk2.Position= -1681,1800,47417
		sk3.Position= 1681,1800,49000
		sk4.Position= -1681,1800,49000
		sk1.Angle=3.0
		sk2.Angle=3.0
		sk3.Angle=3.0
		sk4.Angle=3.0
		CurrentEnemyList.append(sk1.Name)
		CurrentEnemyList.append(sk2.Name)
		CurrentEnemyList.append(sk3.Name)
		CurrentEnemyList.append(sk4.Name)	
		darfuncs.UnhideBadGuy(sk1.Name)
		darfuncs.UnhideBadGuy(sk2.Name)
		darfuncs.UnhideBadGuy(sk3.Name)
		darfuncs.UnhideBadGuy(sk4.Name)
		Bladex.AddScheduledFunc(Bladex.GetTime()+9.0, Advance,(sk1.Name,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+9.4, Advance,(sk2.Name,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+10.0, Advance,(sk3.Name,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+10.4, Advance,(sk4.Name,))
		
		print "OK"
	else:
		pass
		
		
		
		
		
		
		
def  Advance(entity):
	en = Bladex.GetEntity(entity)
	if en.GoTo(153,-1463,-21726):
		print "Advance"
	else:
		print "Not Moving"



def EnemyDeadNoRep(entity):
	BadGuyDead()
	if entity in CurrentEnemyList:
		CurrentEnemyList.remove(entity)




def EnemyDead(entity):
	BadGuyDead()
	if entity in CurrentEnemyList:
		CurrentEnemyList.remove(entity)
		remen=len(CurrentEnemyList)
		print entity+" dead. Remaining "+`remen`
	if len(CurrentEnemyList)== 0:
		global EnemyActive
		EnemyActive=0
		Bladex.AddScheduledFunc(Bladex.GetTime()+35.0, SetUpNextAttack,())
		print "All dead - set up"
	
	
	
	

	
		
		
def SetUpNextAttack():
	print "Set Up Next Attack"
	x,y,z=char.Position
	
	if Bdooropen or z > 20000:
		Bladex.AddScheduledFunc(Bladex.GetTime()+10.0, SetUpNextAttack,())
	else:
		global AttackNum 
		global EnemyActive
		global Enemynum
		Enemynum=Enemynum+1
		AttackNum = AttackNum +1
		if AttackNum==3:
			ActivateClimbers()
		trollmesh=""
		meshpick=whrandom.randint(0, 1)
		if meshpick==1:
			trollmesh="WarTroll_B"
		
		wt=Bladex.CreateEntity("WarTroll_"+`Enemynum`,"WarTroll_A",681,1400,45417, "Person")
		wt.Angle=3.0
		wt.Level=char.Level
		wt.Data=EnemyCharTypes.WarTroll(wt)
		if trollmesh=="WarTroll_B":
			wt.SetMesh(trollmesh)
		CurrentEnemyList.append(wt.Name)
		wp=Bladex.CreateEntity(wt.Name+"WP","Martillo2",0,0,0,"Weapon")
		wp.Scale=1.8
		Actions.TakeObject(wt.Name,wp.Name)
		wt.SetOnFloor()
		wt.Data.LevelupFunc=EnemyCharTypes.WarTrollLevelUpFunc
		wt.Data.LevelupArgs=(wt.Name,)
		wt.Data.DeathFunc=EnemyDead
		wt.Data.DeathArgs=(wt.Name,)
		EnemyCharTypes.WarTrollLevelUpFunc(wt.Name)
		GoTroll(wt.Name)
		
		Enemynum=Enemynum+1
		k1=Bladex.CreateEntity("EnemyKnight"+`Enemynum`,"Knight_Traitor",1681,1800,47417,"Person")
		k1.Level=char.Level
		k1.Angle=3
		k1wp=Bladex.CreateEntity(k1.Name+"WP","Gladius",0,0,0,"Weapon")
		k1sh=Bladex.CreateEntity(k1.Name+"SH","Escudo1",0,0,0,"Weapon")
		ItemTypes.ItemDefaultFuncs(k1sh)
		Actions.TakeObject(k1.Name,k1wp.Name)
		Actions.TakeObject(k1.Name,k1sh.Name)
		k1.Data=EnemyCharTypes.EnemyTraitorKnight(k1)
		k1.SetOnFloor()
		k1.Data.DeathFunc=EnemyDead
		k1.Data.DeathArgs=(k1.Name,)
		k1.Data.LevelupFunc=EnemyCharTypes.TraitorKnightLevelUpFunc
		k1.Data.LevelupArgs=(k1.Name,)
		EnemyCharTypes.TraitorKnightLevelUpFunc(k1.Name)
		Enemynum=Enemynum+1
		k2=Bladex.CreateEntity("EnemyKnight"+`Enemynum`,"Knight_Traitor",-1681,1800,47417,"Person")
		k2.Level=char.Level
		k2.Angle=3
		k2wp=Bladex.CreateEntity(k2.Name+"WP","Maza",0,0,0,"Weapon")
		k2sh=Bladex.CreateEntity(k2.Name+"SH","Escudo1",0,0,0,"Weapon")
		ItemTypes.ItemDefaultFuncs(k2sh)
		Actions.TakeObject(k2.Name,k2wp.Name)
		Actions.TakeObject(k2.Name,k2sh.Name)
		k2.Data=EnemyCharTypes.EnemyTraitorKnight(k2)
		k2.SetOnFloor()
		k2.Data.DeathFunc=EnemyDead
		k2.Data.DeathArgs=(k2.Name,)
		k2.Data.LevelupFunc=EnemyCharTypes.TraitorKnightLevelUpFunc
		k2.Data.LevelupArgs=(k2.Name,)
		EnemyCharTypes.TraitorKnightLevelUpFunc(k2.Name)
		
		Enemynum=Enemynum+1
		k3=Bladex.CreateEntity("EnemyKnight"+`Enemynum`,"Knight_Traitor",-1681,1800,49000,"Person")
		k3.Level=char.Level
		k3.Angle=3
		k3wp=Bladex.CreateEntity(k3.Name+"WP","Gladius",0,0,0,"Weapon")
		k3sh=Bladex.CreateEntity(k3.Name+"SH","Escudo1",0,0,0,"Weapon")
		ItemTypes.ItemDefaultFuncs(k3sh)
		Actions.TakeObject(k3.Name,k3wp.Name)
		Actions.TakeObject(k3.Name,k3sh.Name)
		k3.Data=EnemyCharTypes.EnemyTraitorKnight(k3)
		k3.SetOnFloor()
		k3.Data.DeathFunc=EnemyDead
		k3.Data.DeathArgs=(k3.Name,)
		k3.Data.LevelupFunc=EnemyCharTypes.TraitorKnightLevelUpFunc
		k3.Data.LevelupArgs=(k3.Name,)
		EnemyCharTypes.TraitorKnightLevelUpFunc(k3.Name)
		Enemynum=Enemynum+1
		k4=Bladex.CreateEntity("EnemyKnight"+`Enemynum`,"Knight_Traitor",1681,1800,49000,"Person")
		k4.Level=char.Level
		k4.Angle=3
		k4wp=Bladex.CreateEntity(k4.Name+"WP","Gladius",0,0,0,"Weapon")
		k4sh=Bladex.CreateEntity(k4.Name+"SH","Escudo1",0,0,0,"Weapon")
		ItemTypes.ItemDefaultFuncs(k4sh)
		Actions.TakeObject(k4.Name,k4wp.Name)
		Actions.TakeObject(k4.Name,k4sh.Name)
		k4.Data=EnemyCharTypes.EnemyTraitorKnight(k4)
		k4.SetOnFloor()
		k4.Data.DeathFunc=EnemyDead
		k4.Data.DeathArgs=(k4.Name,)
		k4.Data.LevelupFunc=EnemyCharTypes.TraitorKnightLevelUpFunc
		k4.Data.LevelupArgs=(k4.Name,)
		EnemyCharTypes.TraitorKnightLevelUpFunc(k4.Name)
		CurrentEnemyList.append(k1.Name)
		CurrentEnemyList.append(k2.Name)
		CurrentEnemyList.append(k3.Name)
		CurrentEnemyList.append(k4.Name)	
		Bladex.AddScheduledFunc(Bladex.GetTime()+7.0, Advance,(k1.Name,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+7.4, Advance,(k2.Name,))	
		Bladex.AddScheduledFunc(Bladex.GetTime()+7.8, Advance,(k3.Name,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+8.2, Advance,(k4.Name,))


		
		
		
		
	
	
def GoTroll(entity):
	door1.OpenDoor()
	Bladex.AddScheduledFunc(Bladex.GetTime()+6.0, Advance,(entity,))
	Bladex.AddScheduledFunc(Bladex.GetTime()+14.0,CloseBridgeDoor,())
	EnemyActive=1
		
		
		


def ActArchers():
	for i in AllyArcherList:
		arc=Bladex.GetEntity(i)
		if arc.Life>0:
			arc.Data.AttackOnSight=1
	print "Go Archers"


Shieldholders=["Knight_Traitor","Ork","Great_Ork","Ragnar","Skeleton"]


Spawnpos={}
Spawnpos["Default"]=   [(5434,-1000,-23068),
			(5102,-1000,-27615),
			(5059,-1000,-33209),
			(-4288,-1000,-35360),
			(-4536,-1000,-28634),
			(-4480,-1000,-22350),
			(-6137,-1000,-6398),
			(6869,-1000,-5371),
			(6240,-1000,-10566),
			(3016,-705,22872),
			(-1798,-437,24783)]
			
Spawnpos["Knight_Traitor"]=    [(-1250,2100,46000),
				(1250,2100,46000),
				(-1250,2100,48000),
				(1250,2100,48000),
				(1250,2100,50000),
				(-1250,2100,50000),
				(1250,2100,52000),
				(-1250,2100,52000),
				(1250,2100,54000),
				(-1250,2100,54000),
				(3000,2100,52000),
				(-3000,2100,52000),
				(5000,2100,52000)]


Weps={}  
Weps["Knight_Traitor"]=["Gladius","Maza","Hacha5","Espadaromana","Orksword","Orksword","Espadaelfica","Maza2","QueenSword","HookSword","Espadacurva","EgyptSword","Dagesse","Cimitarra","Katana","Maza3","DoubleSword","DoubleSword","Espadafilo","Espada"]
Weps["Minotaur"]=      ["Garrote","Garrote","Maza","Maza","Garropin","Garropin","Martillo","Martillo","Martillo2","Hachacarnicero","Hachacarnicero","Hachacarnicero","Hachacarnicero","Mazapiedra","Mazapiedra","Mazapiedra","Mazapiedra","Mazapiedra","Martillo3","Martillo3"]
Weps["Ork"]=           ["Gladius","Maza","Hacha3","Espadaromana","Garropin","Orksword","Espadaelfica","Maza2","QueenSword","HookSword","Espadacurva","EgyptSword","Dagesse","Cimitarra","Katana","Maza3","DoubleSword","DoubleSword","Espadafilo","Espada"]
Weps["Great_Ork"]=     ["Gladius","Maza","Maza","Espadaromana","Garropin","Hacha4","Espadaelfica","Maza2","QueenSword","HookSword","Espadacurva","EgyptSword","Dagesse","Cimitarra","Katana","Maza3","DoubleSword","DoubleSword","Espadafilo","Espada"]
Weps["Ragnar"]=        ["ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword"]
Weps["Skeleton"]=      ["Gladius","Maza","Hacha3","Espadaromana","Garropin","Orksword","Espadaelfica","Maza2","QueenSword","HookSword","Espadacurva","EgyptSword","Dagesse","Cimitarra","Katana","Maza3","DoubleSword","DoubleSword","Espadafilo","Espada"]

Shields=["Escudo5","Escudo5","Escudo2","Escudo2","Escudo1","Escudo1","Escudo1","KingShield","KingShield","KingShield","Escudo8","Escudo8","Escudo9","Escudo9","Escudo3","Escudo4","Escudo4","Escudo7","Escudo6","Escudo6"]



def MakeTidyShield(obj_name):
	esc=Bladex.GetEntity(obj_name)
	if not esc.Weapon:
		esc.Static=1
	esc.Weapon=1
	datos_esc=Reference.DefaultObjectData[esc.Kind]

	if datos_esc[0]==Reference.OBJ_SHIELD:
		esc.Cone=datos_esc[4]
		esc.Height=datos_esc[5]
		esc.Radius=datos_esc[6]
		if datos_esc[7]:
			Breakings.SetBreakableWS(obj_name,8,12)
	else:
		esc.Cone=3.1416
		esc.Height=2000
		esc.Radius=750
		if datos_esc[0]==Reference.OBJ_STANDARD or datos_esc[0]==Reference.OBJ_WEAPON:
			if Reference.GiveWeaponFlag(obj_name)<>Reference.W_FLAG_1H:
				esc.Cone=datos_esc[5][1]
				esc.Height=datos_esc[5][2]
				esc.Radius=datos_esc[5][3]
				if datos_esc[5][5]:
					Breakings.SetBreakableWS(obj_name)
			else:
				print "MakeShield. Unexpected weapon FLAG"
		else:
			print "MakeShield. Unexpected type of object"
	esc.HitShieldFunc=Sparks.ThrowSparksShield
	return esc

def GetWeaponType(type,lvl):
	global Weps   
	if Weps.has_key(type):
		wps=Weps[type]
		if lvl<=19:
			WPTYPE=wps[lvl]
		else:
			WPTYPE=wps[19]
  	else:
  		WPTYPE="Cazo"
	return WPTYPE


def GetShieldType(lvl):
	global Shields
	if lvl>19:
		SHTYPE=Shields[19]
	else:
		SHTYPE=Shields[lvl]
	return SHTYPE
	
	
	
	
def AssignData(entity):
	newenemy=Bladex.GetEntity(entity)
	if newenemy.Kind=="Ork" or newenemy.Kind=="Great_Ork":
		newenemy.Data=EnemyCharTypes.EnemyOrk(newenemy)
	elif newenemy.Kind=="Minotaur":
		newenemy.Data=EnemyCharTypes.EnemyMinotaur(newenemy)
	elif newenemy.Kind=="Knight_Traitor" or newenemy.Kind=="Dark_Knight":
		newenemy.Data=EnemyCharTypes.EnemyTraitorKnight(newenemy)
	elif newenemy.Kind=="Ragnar":
		newenemy.Data=EnemyCharTypes.EnemyRagnar(newenemy)
	elif newenemy.Kind=="Skeleton":
		newenemy.Data=EnemyCharTypes.EnemySkeleton(newenemy)
	else:
		print"No Data Available for new enemy"


def SetEnemyFuncs(entity):
	en=Bladex.GetEntity(entity)
	en.Data.DeathFunc=NextEnemy
	en.Data.DeathArgs=(en.Kind,)
	
	
	
def NextEnemy(EntityKind):
	delay=5.0
	if EntityKind=="Minotaur":
		delay=30.0
	Bladex.AddScheduledFunc(Bladex.GetTime()+delay,CreateEnemy,(EntityKind,))
	BadGuyDead()
	
	
def ConcealedAppear(pos,entity):
	en=Bladex.GetEntity(entity)
	char=Bladex.GetEntity("Player1")
	dist=B3DLib.GetXZDistance("Player1",en.Name)
	if dist >4000:
		# check not in Player sight
		if not en.CanISee(char) and not char.CanISee(en):
			things=Bladex.GetEntitiesAt(pos[0],pos[1],pos[2],3000)
			# check that another en is not already in my position
			clear=1
			for id in things:
				possibleen=Bladex.GetEntity(id)
				if possibleen.Person and possibleen.Name!=en.Name:
					if possibleen.Life>0:
						print "Trying to do it, but",id,"is already in my position."
						clear=0
			else:
				if clear==1:
					return 1
				else:
					return 0
		else:
			print "I can't appear here. I can be seen."
			return 0
	else:
		return 0
		
		
	
def CreateEnemy(EntityKind="Knight_Traitor"):
	global Enemynum
	
	en=Bladex.CreateEntity("Enemy_"+str(Enemynum),EntityKind,0,20000,0,"Person")
	lvl=Bladex.GetEntity("Player1").Level+3
	en.Level=lvl
	rwp=Bladex.CreateEntity(en.Name+"RightWeapon",GetWeaponType(EntityKind,lvl),0,20000,0,"Weapon")
	if EntityKind=="Minotaur" and rwp.Kind in ("Maza","Garrote","Martillo","Martillo2","Martillo3"):
		rwp.Scale=1.7
	else:
		rwp.Scale=1.0
	
	Actions.TakeObject(en.Name,rwp.Name)
	
	if EntityKind in Shieldholders:
		sh=Bladex.CreateEntity(en.Name+"Shield",GetShieldType(en.Level),0,20000,0,"Weapon")
		sh.Scale=1.0
		MakeTidyShield(sh.Name)
		Actions.TakeObject(en.Name,sh.Name)
	
	AssignData(en.Name) 
	SetEnemyFuncs(en.Name)
	en.SendTriggerSectorMsgs=1
	darfuncs.HideBadGuy(en.Name)
	en.Alpha=0
	en.CastShadows=0
	PlaceEnemy(en.Name)
	Enemynum=Enemynum+1
	
	
def PlaceEnemy(enemyname):
	en=Bladex.GetEntity(enemyname)
	if en.Alpha>0.9:
		en.Alpha=0
	if Spawnpos.has_key(en.Kind):
		positions=Spawnpos[en.Kind]
	else:
		positions=Spawnpos["Default"]
	pos=positions[whrandom.randint(0, len(positions)-1)]
	en.Position=pos[0], pos[1], pos[2]
	#en.Angle=B3DLib.GetEntity2EntityAngle(en.Name, "Player1")
	en.Angle=3
	darfuncs.HideBadGuy(enemyname)
	if ConcealedAppear(pos,en.Name)==1:
		
		darfuncs.UnhideBadGuy(enemyname)
		en.Alpha=1.0
		en.CastShadows=1
		en.SetOnFloor()
		en.GoTo(0,-1000,0)
		#en.Data.PeriodicLook() ################ 
		Reference.debugprint("All clear - enemy ready to fight")
		
	else:	
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.2,PlaceEnemy,(enemyname,))
		Reference.debugprint("position not good - next try in a mo.")
		
		

	
		
		
		
		
def ActivateClimbers():
	global numclimbers
	interval=whrandom.randint(20, 80)
	
	num=whrandom.randint(1, 5)
	if numclimbers<10:
		for i in range(num):
			GenerateRandomClimber()
			numclimbers=numclimbers+1
	Bladex.AddScheduledFunc(Bladex.GetTime()+interval,ActivateClimbers,())
		
		
def GenerateRandomClimber():
	cpnum=whrandom.randint(0, len(climbpointlist)-1)
	cpnum=cpnum+1
	print cpnum
	if cpnum==1:
		cp1.Data.Deploy()
		print "deploy 1"
	elif cpnum==2:
		cp2.Data.Deploy()
		print "deploy 2"
	elif cpnum==3:
		cp3.Data.Deploy()
		print "deploy 3"
	elif cpnum==4:
		cp4.Data.Deploy()
		print "deploy 4"
	elif cpnum==5:
		cp5.Data.Deploy()
		print "deploy 5"
	elif cpnum==6:
		cp6.Data.Deploy()
	elif cpnum==7:
		cp7.Data.Deploy()
	elif cpnum==8:
		cp8.Data.Deploy()
	elif cpnum==9:
		cp9.Data.Deploy()
	elif cpnum==10:
		cp10.Data.Deploy()
	elif cpnum==11:
		cp11.Data.Deploy()
	elif cpnum==12:
		cp12.Data.Deploy()
	elif cpnum==13:
		cp13.Data.Deploy()
	else:
		cp1.Data.Deploy()
		print "default deploy"
				
		
		
########### Generate Allies

"""
Allynum=0


def NewGuardGroup():
	global Allynum
	Allynum=Allynum+1
	bgda=Bladex.CreateEntity("NewBlackGuard"+`Allynum`,"BlackGuard_Tkn",-3000,-900,-11000, "Person")
	bgda.Angle=0.0
	bgda.Level=3
	bgda.Data=AllyNPCTypes.BlackGuard(bgda)
	bgdawp=Bladex.CreateEntity(bgda.Name+"WP","Maza",0,0,0,"Weapon")
	Actions.TakeObject(bgda.Name ,bgdawp.Name)
	bgdash=Bladex.CreateEntity(bgda.Name+"SH","Escudo4",0,0,0,"Weapon")
	ItemTypes.ItemDefaultFuncs(bgdash)
	Actions.TakeObject(bgda.Name , bgdash.Name)
	bgda.Data=AllyNPCTypes.BlackGuard(bgda)
	bgda.SetOnFloor()
	bgda.Data.DeathFunc=BlackGuardDead
	bgda.Data.DeathArgs=(bgda.Name,)
	bgda.Data.LevelupFunc=AllyNPCTypes.BlackGuardLevelUpFunc
	bgda.Data.LevelupArgs=(bgda.Name,)
	AllyNPCTypes.BlackGuardLevelUpFunc(bgda.Name)

	Allynum=Allynum+1
	bgdb=Bladex.CreateEntity("NewBlackGuard"+`Allynum`,"BlackGuard_Tkn",-3000,-900,-11000, "Person")
	bgdb.Angle=0.0
	bgdb.Level=3
	bgdb.Data=AllyNPCTypes.BlackGuard(bgdb)
	bgdbwp=Bladex.CreateEntity(bgdb.Name+"WP","Maza2",0,0,0,"Weapon")
	Actions.TakeObject(bgdb.Name ,bgdbwp.Name)
	bgdbsh=Bladex.CreateEntity(bgdb.Name+"SH","Escudo4",0,0,0,"Weapon")
	ItemTypes.ItemDefaultFuncs(bgdbsh)
	Actions.TakeObject(bgdb.Name , bgdbsh.Name)
	bgdb.Data=AllyNPCTypes.BlackGuard(bgdb)
	bgdb.SetOnFloor()
	bgdb.Data.DeathFunc=BlackGuardDead
	bgdb.Data.DeathArgs=(bgdb.Name,)
	bgdb.Data.LevelupFunc=AllyNPCTypes.BlackGuardLevelUpFunc
	bgdb.Data.LevelupArgs=(bgdb.Name,)
	AllyNPCTypes.BlackGuardLevelUpFunc(bgdb.Name)
"""


def ActReserves1():
	OperateMainGate()
	darfuncs.UnhideBadGuy("BlackGuard5")
	darfuncs.UnhideBadGuy("BlackGuard6")
	darfuncs.UnhideBadGuy("BlackGuard7")
	darfuncs.UnhideBadGuy("BlackGuard8")
	SignOn("BlackGuard5")
	SignOn("BlackGuard6")
	SignOn("BlackGuard7")
	SignOn("BlackGuard8")
	AlliesActive.append("BlackGuard5")
	AlliesActive.append("BlackGuard6")
	AlliesActive.append("BlackGuard7")
	AlliesActive.append("BlackGuard8")
	print "reserves go.....>>>"
	
	
	
	
	
################################################################################################################################################################################################


def MakeBigTorch(entity, intens=10, smoke=0):
	tor=Bladex.GetEntity(entity)
	tor.CastShadows=0
	x,y,z = tor.GraspPos("Spot")
	fx,fy,fz=tor.GraspPos("Flame")
	luz = Bladex.CreateEntity(tor.Name+"Spot","Entity Spot",x,y,z)
	luz.Color=255, 196, 128
	luz.Intensity=intens
	luz.Precission=0.05
	luz.Visible=0
	luz.CastShadows=0
	luz.Flick=1
	
	

	torps=Bladex.CreateEntity(tor.Name+"Fire", "Entity Particle System D1", fx,fy,fz)
	torps.ParticleType="Fire"
	torps.YGravity=-2000.0
	torps.Friction=0.12
	torps.PPS=128
	torps.Velocity= 0.0, -1200.0, 0.0
	torps.Time2Live=21
	torps.RandomVelocity=12
	
	if smoke:
		smoke1=Bladex.CreateEntity(tor.Name+"Smoke", "Entity Particle System D1", fx,fy-500,fz)
		smoke1.ParticleType="GreySmoke"
		smoke1.YGravity=-500.0
		smoke1.Friction=0.12
		smoke1.PPS=30  
		smoke1.Velocity = 0.0, -2000.0, 0.0
		smoke1.Time2Live=50
		smoke1.RandomVelocity=30



################################################################################################################################################################################################
############# doors - gates - elevators

MainGateOpen=0
MainGateMoving=0

def OperateMainGate():
	global MainGateOpen
	global MainGateMoving
        desplazamientos=(2600, 600)
        if MainGateMoving:
        	return
        
        if MainGateOpen:
       		vectores=((0.0, 1.0, 0.0), (0.0, 1.0, 0.0))
       		gatedoora.CloseDoor()
       		gatedoorb.CloseDoor()
       	else:
       		vectores=((0.0, -1.0, 0.0), (0.0, -1.0, 0.0))
       		gatedoora.OpenDoor()
       		gatedoorb.OpenDoor()
       	vel_iniciales=(500.0, 1000)
        vel_finales=(1000.0, 500)
        son_durante=(deslizrasanexo, deslizrasanexo)
        son_finales=("", golperasanexo)
        Objects.NDisplaceObject(gate1din, desplazamientos, vectores, vel_iniciales, vel_finales, (), son_durante, son_finales,"",(), GateEnd)
	MainGateMoving=1




def GateEnd():
	global MainGateOpen
	global MainGateMoving
	MainGateMoving=0
	if MainGateOpen:
		MainGateOpen=0
	else:
		MainGateOpen=1





def BridgeDoorOpen():
	global Bdooropen
	Bdooropen = 1
	

def BridgeDoorClosed():
	global Bdooropen
	Bdooropen = 0
	
	
def CloseBridgeDoor():
	x,y,z=char.Position
	if CheckToCloseBridgeDoor() and z < 35000:
		door1.CloseDoor()
	else:
		Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, CloseBridgeDoor,())
		
		
def CheckToCloseBridgeDoor():
	for i in Bladex.GetEntitiesAt(0,2000,42250,5000):	
		ent=Bladex.GetEntity(i)
		if ent and ent.Person:
			if ent.Life>0 and Bdooropen:
				return 0
	return 1


def ArchDoorOpen():
	global Adooropen
	Adooropen = 1
	

def ArchDoorClosed():
	global Adooropen
	Adooropen = 0
	
	
	
	
def CloseArchGate():
	if Adooropen:
		door2a.CloseDoor()
		door2b.CloseDoor()
	
	
def OpenArchGate():
	door2a.OpenDoor()
	door2b.OpenDoor()

################################################################################################################################################################################################
############# Climbers










################################################################################################################################################################################################

### Test stuff



def IrPosicion1():
	
	char=Bladex.GetEntity("Player1")
	char.Position=153,-1463,-21726	# start
	

def IrPosicion2():
	
	char=Bladex.GetEntity("Player1")
	char.Position=5000,-11300,43000               #bridge tower
	

def IrPosicion3():
	
	char=Bladex.GetEntity("Player1")
	char.Position= -142000,-7463,48000	
	char.Angle=0

def IrPosicion4():
	
	char=Bladex.GetEntity("Player1")
	char.Position=153,-1463,-21726
	

def IrPosicion5():
	
	char=Bladex.GetEntity("Player1")
	char.Position=153,-1463,-21726		
	

def IrPosicion6():
	
	char=Bladex.GetEntity("Player1")
	char.Position=153,-1463,-21726	
	

def IrPosicion7():
	
	char=Bladex.GetEntity("Player1")
	char.Position=153,-1463,-21726		
	

def IrPosicion8():
	
	char=Bladex.GetEntity("Player1")
	char.Position=153,-1463,-21726	
	

def IrPosicion9():
	
	char=Bladex.GetEntity("Player1")
	char.Position=153,-1463,-21726	
	







def WritePos():
	char=Bladex.GetEntity("Player1")
	x=int(char.Position[0])
	y=int(char.Position[1])
	z=int(char.Position[2])
	file = open("../../BODLoader/Mods/ChaosKnightMap/pos.txt","a")
        file.write("("+str(x)+","+str(y)+","+str(z)+")"+"\n")
        file.close()
        
       
       
       
       
       
def TestAnim1():
	print "anim1"
	char.LaunchAnmType("g_m01")
       
def TestAnim2():
	print "anim2"
	char.LaunchAnimation("Dwf_attack_l")
	
	
	
	

	
	
Slomo=0

def ToggleSlomo():
	global Slomo
	cx,cy,cz=char.Position
	x,y,z=char.Rel2AbsPoint(0,-5000,800)
	if Slomo==0:
		Slomo=1
		Bladex.SetTimeSpeed(0.4)
		cam.SType = 0
		cam.TType = 0
		cam.Position=x,y,z
		cam.TPos=cx,cy,cz
		Slomo=1
		print"Slomo on"
	else:
		Slomo=0	
		Bladex.SetTimeSpeed(1.0)
		cam.SetPersonView("Player1")
		cam.Cut()
		Slomo=0	
		print"Slomo off"








def InitEB():
	import EBrowser
	print "EBStart"



Scoreron=1

def HideScorer():
	global Scoreron
	if Scoreron==1:
		Scorer.SetVisible(0)
		Scoreron=0
	else:
		Scorer.SetVisible(1)
		Scoreron=1












	
	
Tnum=0


def CreateTarget():
	#cp4.Deploy()
	
	cpnum=whrandom.randint(0, len(climbpointlist)-1)
	cpnum=cpnum+1
	print cpnum
	if cpnum==1:
		cp1.Data.Deploy()
		print "deploy 1"
	elif cpnum==2:
		cp2.Data.Deploy()
		print "deploy 2"
	elif cpnum==3:
		cp3.Data.Deploy()
		print "deploy 3"
	elif cpnum==4:
		cp4.Data.Deploy()
		print "deploy 4"
	else:
		cp1.Data.Deploy()
		print "default deploy"
		
		
		
		

if Reference.PYTHON_DEBUG >= 1:
	Bladex.AddInputAction("HideScorer", 0)
	Bladex.AddBoundFunc("HideScorer", HideScorer)
	Bladex.AssocKey("HideScorer", "Keyboard", "B", 1)

	
	Bladex.AddInputAction("InitEB", 0)
	Bladex.AddBoundFunc("InitEB", InitEB)
	Bladex.AssocKey("InitEB", "Keyboard", "X", 1)

	Bladex.AddInputAction("WritePos", 0)
	Bladex.AddBoundFunc("WritePos", WritePos)
	Bladex.AssocKey("WritePos", "Keyboard", "I", 1)

	

	Bladex.AddInputAction("ToggleSlomo", 0)
	Bladex.AddBoundFunc("ToggleSlomo", ToggleSlomo)
	Bladex.AssocKey("ToggleSlomo", "Keyboard", "U", 1)
	
	Bladex.AddInputAction("GenerateRandomClimber", 0)
	Bladex.AddBoundFunc("GenerateRandomClimber", GenerateRandomClimber)
	Bladex.AssocKey("GenerateRandomClimber", "Keyboard", "V", 1)
	
	#Bladex.AddInputAction("Advance", 0)
	#Bladex.AddBoundFunc("Advance", Advance)
	#Bladex.AssocKey("Advance", "Keyboard", "M", 1)

	