######################################################
#
# Create sets of attacks
#
#        - BGD -
#
######################################################


import Bladex

ATK_UNIQUE=0
ATK_RANDOM=1
ATK_SEQUENTIAL=2



# Predeclare & link all my combos into ATTACKING action event tables

Bladex.SetActionEventTable("Bgd","g_01","ATTACKING")
Bladex.SetActionEventTable("Bgd","g_02","ATTACKING")
Bladex.SetActionEventTable("Bgd","g_05","ATTACKING")
Bladex.SetActionEventTable("Bgd","g_07","ATTACKING")
Bladex.SetActionEventTable("Bgd","g_08","ATTACKING")
Bladex.SetActionEventTable("Bgd","g_11","ATTACKING")
Bladex.SetActionEventTable("Bgd","g_13","ATTACKING")
Bladex.SetActionEventTable("Bgd","g_14","ATTACKING")
Bladex.SetActionEventTable("Bgd","g_16","ATTACKING")
Bladex.SetActionEventTable("Bgd","g_18","ATTACKING")


Bladex.SetActionEventTable("Bgd","g_spears1","ATTACKING")
Bladex.SetActionEventTable("Bgd","g_spear08","ATTACKING")
Bladex.SetActionEventTable("Bgd","g_spear12","ATTACKING")
Bladex.SetActionEventTable("Bgd","g_spears6","ATTACKING")
Bladex.SetActionEventTable("Bgd","g_spear16low","ATTACKING")
Bladex.SetActionEventTable("Bgd","g_tw5","ATTACKING")
Bladex.SetActionEventTable("Bgd","order","ATTACKING")




# Predeclare & link all my dodges into DODGING action event tables
Bladex.SetActionEventTable("Bgd","D_r", "DODGING")
Bladex.SetActionEventTable("Bgd","D_l", "DODGING")
Bladex.SetActionEventTable("Bgd","D_b", "DODGING")



bgd=Bladex.GetCharType("BlackGuard_Tkn","Bgd")

###############################
# GRUPOS DE GOLPES ALEATORIOS #
###############################
#GA group

bgd.AddAttack("GA","Bgd_g_01")
bgd.AttackWindow("Bgd_g_01",5,15,"GA_Window")

bgd.AddAttack("GA","Bgd_g_02")
bgd.AttackWindow("Bgd_g_02",5,15,"GA_Window")

bgd.AddAttack("GA","Bgd_g_07")
bgd.AttackWindow("Bgd_g_07",5,15,"GA_Window")

bgd.AddAttack("GA","Bgd_g_08")
bgd.AttackWindow("Bgd_g_08",5,15,"GA_Window")

bgd.AttackTypeFlag("GA",ATK_RANDOM)

###############################
# GRUPOS DE GOLPES SELECTIVOS #
###############################

#GM1 group
bgd.AddAttack("GM1","Bgd_g_13")
bgd.AddAttack("GM1","Bgd_g_16")

bgd.AttackTypeFlag("GM1",ATK_SEQUENTIAL)

#GM2 group
bgd.AddAttack("GM2","Bgd_g_13")
bgd.AddAttack("GM2","Bgd_g_16")
bgd.AddAttack("GM2","Bgd_g_18")

bgd.AttackTypeFlag("GM2",ATK_SEQUENTIAL)


###############################
# GRUPO PARA ESCALERAS        #
###############################
bgd.AddAttack("STAIRS","Bgd_g_08")
bgd.AddAttack("STAIRS","Bgd_g_01")

bgd.AddAttack("STAIRS","Bgd_g_18")
bgd.AddAttack("STAIRS","Bgd_g_14")


bgd.AttackTypeFlag("STAIRS",ATK_RANDOM)


bgd.AddAttack("GTH5","Bgd_g_tw5")	# Launched Weapon

bgd.AddAttack("Flame","Bgd_order")


#################################
###### New Spear Stuff

#GI "group"
bgd.AddAttack("GI_SP","Bgd_g_spears1")
bgd.AttackWindow("Bgd_g_spears1",0.334,0.642,"GI_SP_Window")
#bgd.AttackTypeFlag("GI_SP",ATK_UNIQUE) #If only one attack given , UNIQUE flag is applied


#COMBO1 group
bgd.AddAttack("GM1_SP","Bgd_g_spear08")
bgd.AttackWindow("Bgd_g_spear08",0.121,0.496,"GM1_SP_Window")
bgd.AddLevels("Bgd_g_spear08",0,40)

#COMBO2 group
bgd.AddAttack("GM3_SP","Bgd_g_spear12")
bgd.AttackWindow("Bgd_g_spear12",0.183,0.448,"GM3_SP_Window")
bgd.AddLevels("Bgd_g_spear12",0,40)


#COMBO3 group
bgd.AddAttack("GM6_SP","Bgd_g_spears6")
bgd.AttackWindow("Bgd_g_spears6",0.345,0.454,"GM6_SP_Window")
bgd.AddLevels("Bgd_g_spears6",0,40)


#COMBO4 group
bgd.AddAttack("GM8_SP","Bgd_g_spear16low")
bgd.AttackWindow("Bgd_g_spear16low",0.341,0.475,"GM8_SP_Window")
bgd.AddLevels("Bgd_g_spear16low",0,40)



