import Bladex
import CharStats
import Reference
import Actions
import math
import whrandom
import B3DLib
import ItemTypes
import darfuncs
import GameStateAux

import EnemyCharTypes








	
	
##########################################################################################################################################################
### SkeletonDRTP uses specialy designed blade. They are awkward for other chars to weild so you can't pick them up.

	
WPHit=[5,8,15,25,35,50,65,85,100,120,150,190,240,300,380,460,550,650,820,950]
WPDef=[0,-3, -5, -10, -15, -20, -25,-30, -35, -40, -45, -50, -55, -60, -65, -70,-75, -80,-85]
	
Weps=["Garrote","Hacha","Hacha3","Maza","Garropin","Orksword","Espadaelfica","Maza2","HookSword","Martillo2","Espadacurva","EgyptSword","Dagesse","Cimitarra","Garrote2","Maza3","DoubleSword","DoubleSword","Espadafilo","Espada"]
	
	
	



class ClimberPoint (ItemTypes.PersistantItemType):

	def __init__(self, me, angle, entitykind):
		ItemTypes.PersistantItemType.__init__(self, me)
		
		self.XDeathFunc=None
		self.XDeathArgs=()
		self.Active=1
		self.Name=me.Name
		self.age_num=0
		self.trsectorname=""
		self.EntityKind=entitykind
		self.spawnangle=angle
		self.Active=0
		self.ClimberDeployed=0
		self.RASMeshes= ["", "Dwarf_M","Dwarf_L","DwfSkin1","DwfSkin2", "Enano1","Enano2","Enano3","Enano4"]
		self.position=me.Position
		
		#Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, self.SetTrigger, ())
		




	# trigger sector (if needed)
	
	def SetTrigger(self, radius=2000.0, floor_displ=1000.0, roof_displ=2000.0):
		x = Bladex.GetEntity(self.Name).Position[0]
		y = Bladex.GetEntity(self.Name).Position[1]
		z = Bladex.GetEntity(self.Name).Position[2]
		dx=radius/2.0
		dz=radius*((math.sqrt(3.0))/2.0)
		self.trsector_name=self.Name+"_TrSector"
		Bladex.AddTriggerSector(self.trsector_name, "SectoresTriggerSkelHole", y+floor_displ, y-roof_displ, [(x+dx, z+dz), (x-dx, z+dz), (x-radius, z), (x-dx, z-dz), (x+dx, z-dz), (x+radius, z)])
		Bladex.SetTriggerSectorFunc(self.trsector_name, "OnLeave", self.InitSpawnClimber)
		print "Climber Trigger Set"
		
		
	def InitSpawnClimber(self,sector,entity):
		per=Bladex.GetEntity(entity)
		if per.Name=="Player1": ################ others?
			if per.Life>0:
				if self.Active==1:
					self.Active=0
					print"Try to spawn climber"
					self.TryToSpawnClimber()

	#### Spawning
	
	
	

				
	def Deploy(self):
		if self.Active:
			Bladex.AddScheduledFunc(Bladex.GetTime()+6.0, self.Deploy,())
			print "position occupied - return"
			return
		self.Active=1
		x, y, z = Bladex.GetEntity(self.Name).Position
		ents=Bladex.GetEntitiesAt(x, y-900, z, 2000)
		for id in ents:
			o = Bladex.GetEntity(id)
			if o.Person:
				if o.Life > 0:
					if o.Alpha >0.01:
						print "Trying to do it, but",id,"is bothering. Next try in 3 seconds."
						Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, self.Deploy,())
						return
		self.CreateClimber(self.Name)
		print"All clear -> create CLIMBER"
					
					
	def CreateClimber(self,EntityName):
		me=Bladex.GetEntity(EntityName)
		me.Position=self.position[0], self.position[1], self.position[2]
		
		char= Bladex.GetEntity("Player1")##### spawn at current Player Level
		lvl=char.Level+3
		self.age_num = self.age_num +1
		if not self.EntityKind:
			return
		# y param must be the right hight above the platform
		clmbr=Bladex.CreateEntity(self.Name+"GenClimber"+`self.age_num`,self.EntityKind, self.position[0], self.position[1]-1150, self.position[2],"Person")
		MESH=""
		skinum=whrandom.randint(0, len(self.RASMeshes)-1)
		MESH=self.RASMeshes[skinum]
		if MESH != "":
			clmbr.SetMesh(MESH)
		
		WEAPONTYPE=Weps[clmbr.Level]
		rwp=Bladex.CreateEntity(clmbr.Name+"WP",WEAPONTYPE,0,0,0,"Weapon")
		Actions.TakeObject(clmbr.Name,rwp.Name)
		
		clmbr.Data=EnemyCharTypes.EnemyDwarf(clmbr)
		
		clmbr.Data.AttackOnSight=0
		clmbr.Data.Combatant=0
		clmbr.Angle=self.spawnangle
		clmbr.Level=lvl
		clmbr.Freeze()
		clmbr.SendTriggerSectorMsgs=1
		clmbr.Life=CharStats.GetCharMaxLife(clmbr.Kind,clmbr.Level)
		self.XDeathArgs=(clmbr.Name,)
		clmbr.Data.OldImDeadFunc=clmbr.ImDeadFunc
		clmbr.ImDeadFunc=self.ClimberImDeadFunc
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.1,self.SpawnClimber,(EntityName,clmbr.Name,))
		
		
		
	def SpawnClimber(self,EntityName,ClimberName):
		self.ClimberDeployed=0
		anm="Dwf_clmb_high_1h"
		x, y, z = Bladex.GetEntity(EntityName).Position
		clmbr=Bladex.GetEntity(ClimberName)
		#pos=clmbr.Position
		clmbr.UnFreeze()
		print "ready to jump"
		clmbr.Wuea=Reference.WUEA_ENDED
		clmbr.SetTmpAnmFlags(1,1,1,0,5,1,0)
		clmbr.LaunchAnimation(anm)
		
		
		clmbr.AnmEndedFunc=self.ActivateClimber
		Bladex.AddScheduledFunc(Bladex.GetTime()+4.0,self.CheckClimber,(clmbr.Name,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.5,self.TempShiftPlatform,())
		
		
	def TempShiftPlatform(self):
		me=Bladex.GetEntity(self.Name)
		me.Position= self.position[0], self.position[1]+20000, self.position[2]
		
		
		
	def CheckClimber(self, ClimberName):
		clmbr=Bladex.GetEntity(ClimberName)
		if clmbr.Life<=0:
			return
		if not self.ClimberDeployed:
			clmbr.Life=0
			self.Active=0
			print "Failed Jump - kill off"
			
			
	
		
	def ActivateClimber(self, ClimberName):
		self.ClimberDeployed=1
		clmbr=Bladex.GetEntity(ClimberName)
		clmbr.Data.Combatant=1
		clmbr.Data.AttackOnSight=1
		self.Active=0
		clmbr.Data.StdSeeTheEnemy(ClimberName)
		clmbr.AnmEndedFunc=None
		
		print "Done"
		
		
	def ClimberImDeadFunc (self,ClimberName):
		clmbr = Bladex.GetEntity(ClimberName)
		clmbr.Data.OldImDeadFunc(ClimberName)
		if self.XDeathFunc:
			apply(self.XDeathFunc, self.XDeathArgs)
		
		
		
	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		state[1]["ClimberPoint"]=(self.trsector_name,
						self.Active,
						self.age_num,
						self.Name,
						self.EntityKind,
						self.spawnangle,
						self.Active,
						self.ClimberDeployed,
						GameStateAux.SaveFunctionAux(self.XDeathFunc),
		                                self.XDeathArgs,
						)
		return state
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["ClimberPoint"]
			self.trsector_name=parms[0]
			self.Active=parms[1]
			self.age_num=parms[2]
			self.Name=parms[3]
			self.EntityKind=parms[4]
			self.spawnangle=parms[5]
			self.Active=parms[6]
			self.ClimberDeployed=parms[7]
			GameStateAux.LoadFunctionAux(parms[8],self,"XDeathFunc")
			self.XDeathArgs=parms[1]
			
		else:
			self.trsector_name=""
			self.Active=1
			self.age_num=0
			self.Name=""
			self.EntityKind="Skeleton"
			self.spawnangle=0
			self.Active=0
			self.ClimberDeployed=0
			self.XDeathFunc=None
			self.XDeathArgs=()
				
	

		
def CreateClimberPoint(name, pos, angle, EntityKind="Dwarf_N"):
	offset=2500
	scale=1.6
	hole=Bladex.CreateEntity(name,"Plataforma",pos[0],pos[1]+offset,pos[2], "Physic")
	hole.Orientation=(0.707,-0.707,0.0,0.0)
	hole.Scale=scale
	hole.Alpha=0 
	hole.CastShadows=0
	hole.Data=ClimberPoint(hole, angle, EntityKind)
	return hole	